var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-283ED424-E506-4A29-848F-9EAC8F1C4AF9\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>FBX Properties</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-283ED424-E506-4A29-848F-9EAC8F1C4AF9\"></a><div class=\"head\">\n            <h1>FBX Properties</h1>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_1ECF33754FA3443A96D04CAE5AB6FD84\"></a> \n            <h2><a name=\"GUID-BEC0C7DE-E961-4AC4-99D6-E911AE3AB4EF\"></a>Managing Properties\n            </h2> \n            <p><a name=\"GUID-1E90D50F-C53C-46C0-99E8-9F1BFE8C7771\"></a>The \n               		  <span class=\"code\">FbxProperty</span> template class is used to ensure that the data of a \n               		  <span class=\"code\">FbxObject</span> is strongly typed. For example, the local translation vector of a \n               		  <span class=\"code\">FbxNode</span> is described using a \n               		  <span class=\"code\">FbxPropertyT</span> which is parametrized for \n               		  <span class=\"code\">FbxDouble3</span>. \n               		\n            </p> \n            <p><a name=\"GUID-B4505FE2-F63D-469D-A0BE-DF8C7B6A161B\"></a>When a \n               		  <span class=\"code\">FbxObject</span> is created, its static built-in \n               		  <span class=\"code\">FbxProperty</span>s are automatically initialized. To create your own \n               		  <span class=\"code\">FbxProperty</span>, you must invoke \n               		  <span class=\"code\">FbxProperty::Create()</span>, and pass either a reference to a \n               		  <span class=\"code\">FbxObject</span>, or to another \n               		  <span class=\"code\">FbxProperty</span>. \n               		\n            </p> \n            <p><a name=\"GUID-C4E6B464-F7EE-4627-BFE6-5B713746C5A2\"></a>The following code sample was taken from the \n               		  <span class=\"char_link\"><a href=\"\">Animation</a></span> example. In this sample, the first parameter of \n               		  <span class=\"code\">FbxProperty::Create()</span> is a \n               		  <span class=\"code\">FbxScene</span> object. The second parameter is the datatype of the property (a full list of datatypes\n               can be found in the \n               		  <span class=\"code\">fbxdatatypes.h</span> header file). The third parameter is the assigned name of the property. \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>FbxProperty p = FbxProperty::Create(pScene, DTDouble3, \"Vector3Property\");\nFbxSet&lt;FbxDouble3&gt;(p, FbxDouble3(1.1, 2.2, 3.3);</pre></div> \n            <p><a name=\"GUID-BAF05026-3A14-4680-A408-F7F02618E7E7\"></a>The name with which a \n               		  <span class=\"code\">FbxProperty</span> is created can be accessed by calling \n               		  <span class=\"code\">FbxProperty::GetName()</span>. This name can be used to search for a property within a hierarchy (see \n               		  <span class=\"char_link\"><a href=\"\">Property Hierarchy</a></span>). \n               		\n            </p> \n            <p><a name=\"GUID-0A4DA2EC-8B2F-408F-9427-538759F85DA3\"></a>An instance of \n               		  <span class=\"code\">FbxProperty</span> can be destroyed by calling \n               		  <span class=\"code\">FbxProperty::Destroy()</span>. A hierarchy of \n               		  <span class=\"code\">FbxProperty</span> can be destroyed by invoking \n               		  <span class=\"code\">FbxProperty::DestroyRecursively()</span> on the root property. \n               		\n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_1E7A9F74F33F4D0CA2C167A520839792\"></a> \n            <h2><a name=\"GUID-5FD1AE88-EF14-4E73-B917-8A792FC6492B\"></a>Property Data\n            </h2> \n            <p><a name=\"GUID-D0524F3A-FB9D-4E9E-948E-38E0DCF5D244\"></a>Instances of \n               		  <span class=\"code\">FbxProperty</span> contain data which can be set and accessed by respectively calling \n               		  <span class=\"code\">FbxProperty::Set()</span> and \n               		  <span class=\"code\">FbxProperty::Get()</span>. For example, the \n               		  <span class=\"code\">FbxNode</span> geometric transformation data, represented as vectors of \n               		  <span class=\"code\">FbxDouble3</span>, can be accessed in the following way: \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>// ... initialize FbxNode* lNode ...\nFbxDouble3 translation = lNode-&gt;LclTranslation.Get();\nFbxDouble3 rotation = lNode-&gt;LclRotation.Get();\nFbxDouble3 scaling = lNode-&gt;LclScaling.Get();</pre></div> \n            <p><a name=\"GUID-FDFBB62D-7A48-46D5-A150-5CCB318E7A5D\"></a>The data contained within a \n               		  <span class=\"code\">FbxPropertyT</span> can only be set to a value that is valid for the property\'s data type. Some implicit\n               conversions are supported; you can, for example, provide an \n               		  <span class=\"code\">int</span> when a \n               		  <span class=\"code\">double</span> is required. \n               		\n            </p> \n            <div class=\"section\"><a name=\"SECTION_CE8B44D4FA3941BAAB752EC00FBB5238\"></a> \n               <h3><a name=\"GUID-BACDDB39-69F7-49E7-B3BE-826A7A9D1C34\"></a>Flags\n               </h3> \n               <p><a name=\"GUID-3CE5ECDB-B09A-4B11-BBA5-53BA91199847\"></a>Properties also contain a set of \n                  			 <span class=\"code\">FbxPropertyFlags::eFbxPropertyFlags</span> which can be manipulated using \n                  			 <span class=\"code\">FbxProperty::GetFlag()</span> and \n                  			 <span class=\"code\">FbxProperty::ModifyFlag()</span>. \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_F56D5A31C63A46498A1C91F1AB925A89\"></a> \n               <h3><a name=\"GUID-692159E0-E036-400E-942F-441369CEDF55\"></a>Operators\n               </h3> \n               <p><a name=\"GUID-655F4057-D5DB-4608-84FB-5E8599BC5044\"></a>The standard comparison and assignment operators can be used to compare and assign\n                  properties to one another (<span class=\"code\">FbxProperty::operator==()</span>, \n                  			 <span class=\"code\">FbxProperty::operator!=()</span>, \n                  			 <span class=\"code\">FbxProperty::operator=()</span>). \n                  		  \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_8C24D7AAEF3C444E9931D011682AB385\"></a> \n               <h3><a name=\"GUID-AB84D16D-892B-471D-A80F-92AE88E3F679\"></a>User-defined Data\n               </h3> \n               <p><a name=\"GUID-5909486E-7B30-46CA-8DD9-6B11D5DD922B\"></a>The \n                  			 <span class=\"code\">FbxProperty</span> class can contain user-defined data, which can be dynamically associated to a \n                  			 <span class=\"code\">FbxObject</span> at runtime. An example of this can be found in the \n                  			 <span class=\"char_link\"><a href=\"\">UserProperties</a></span> example. \n                  		  \n               </p> \n            </div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_3074CD354C7444A89B7066CBB90302BC\"></a> \n            <h2><a name=\"GUID-DAFD48EC-5573-42AD-B01F-F1BC88B365D4\"></a>Property Hierarchy\n            </h2> \n            <p><a name=\"GUID-9BC421E2-618B-4EF6-BEE9-B31D52491452\"></a>Properties can be organized in a hierarchy. A \n               		  <span class=\"code\">FbxProperty</span> can be connected to a \n               		  <span class=\"code\">FbxObject</span>, or to another \n               		  <span class=\"code\">FbxProperty</span>. The bound \n               		  <span class=\"code\">FbxObject</span> of the property can be accessed by invoking \n               		  <span class=\"code\">FbxProperty::GetFbxObject()</span>. The \n               		  <span class=\"char_link\"><a href=\"\">ExportScene05</a></span> example illustrates the construction of a property hierarchy. \n               		\n            </p> \n            <div class=\"section\"><a name=\"SECTION_5BC4F26C057F4CC79375561BFA4BE591\"></a> \n               <h3><a name=\"GUID-3D048459-92E8-4AA8-BDB9-A309C25188C0\"></a>Accessing an FBX Object\'s Properties\n               </h3> \n               <p><a name=\"GUID-2B50824E-45EF-440B-A28C-156C2B7D4EBB\"></a>An \n                  			 <em class=\"strong\">FBX object</em> can have many properties, which can be searched for using \n                  			 <span class=\"code\">FbxObject::FindProperty()</span>. An object\'s properties can also be iterated by invoking methods such as \n                  			 <span class=\"code\">FbxObject::GetFirstProperty()</span>, and \n                  			 <span class=\"code\">FbxObject::GetNextProperty()</span>. \n                  			 \n                  <div><a name=\"GUID-6B63E4AE-3887-423E-BC5B-ADAC97D55D55\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The class documentation of \n                        				<span class=\"code\">FbxIOSettings</span> provides useful insight into the organization of its property hierarchy. \n                        			 \n                     </div>\n                  </div> \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_A17978D879904B97832115941601BB7E\"></a> \n               <h3><a name=\"GUID-9FCC8420-7DA8-4483-9FB4-01A3A704E6C0\"></a>Navigating a Property Hierarchy\n               </h3> \n               <p><a name=\"GUID-B402A5D7-CC90-4D15-B1C7-C97E777FF614\"></a>A \n                  			 <em class=\"strong\">hierarchy of FBX properties</em> can be traversed by means of the FBX property navigation functions: \n                  			 <span class=\"code\">FbxProperty::GetParent()</span>, \n                  			 <span class=\"code\">FbxProperty::GetChild()</span>, \n                  			 <span class=\"code\">FbxProperty::GetSibling()</span>, \n                  			 <span class=\"code\">FbxProperty::Find()</span>, to name but a few. \n                  		  \n               </p> \n            </div> \n            <p><a name=\"GUID-79F877CF-9549-43FC-B60E-FD5A81996262\"></a> \n               <div><a name=\"GUID-8C6EEFEF-B6E2-4A34-A6E8-36787EA95AFB\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The \n                     			 <span class=\"char_link\"><a href=\"GUID-BB63A93A-7663-4256-B060-8EA35CB0FF3A.htm\">Connections</a></span> topic provides more information on how to navigate between objects and property hierarchies.\n                     \n                     		  \n                  </div>\n               </div> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_856C0763033E4397A24D646E09F4724C\"></a> \n            <h2><a name=\"GUID-13AA4696-52A5-447F-8DA3-B756019C4DC2\"></a>Sample Code\n            </h2> \n            <p><a name=\"GUID-6384A5DE-9845-44B1-A421-75987B3BD3F8\"></a>The following sample code was taken from the \n               		  <span class=\"char_link\"><a href=\"\">ExportScene05</a></span> example. It illustrates how to create your own \n               		  <span class=\"code\">FbxProperty</span> values, and bind them to a \n               		  <span class=\"code\">FbxObjectMetaData</span> instance (which inherits from \n               		  <span class=\"code\">FbxObject</span>). \n               		\n            </p> \n            <div class=\"codeBlock\"><pre>// ... initialize pScene as a FbxScene* ...\n\n// Create a FbxObjectMetaData* object in pScene.\nFbxObjectMetaData* lFamilyMetaData = FbxObjectMetaData::Create(pScene, \"Family\");\n\n// Create and assign data to several instances of FbxProperty, based on their parametrized\n// datatypes (DTString, DTFloat, DTDouble). \n//\n// The fourth parameter is an optional label string, which can be obtained and modified\n// using FbxProperty::GetLabel() and FbxProperty::SetLabel(). This label only exists\n// in the program\'s main memory, and will not be exported to a file if/when the property\n// is exported.\n// \n// These properties will be contained within the pFamilyMetaData object.\n//\nFbxProperty::Create(lFamilyMetaData, DTString, \"Level\", \"Level\").Set(FbxString(\"Family\")); // String\nFbxProperty::Create(lFamilyMetaData, DTString, \"Type\", \"Type\").Set(FbxString(\"Wall\"));     // String\nFbxProperty::Create(lFamilyMetaData, DTFloat, \"Width\", \"Width\").Set(10.0f);              // float\nFbxProperty::Create(lFamilyMetaData, DTDouble, \"Weight\", \"Weight\").Set(25.0);            // double\nFbxProperty::Create(lFamilyMetaData, DTDouble, \"Cost\", \"Cost\").Set(1.25);                // double</pre></div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";