var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-29727281-5732-4F89-A06A-BBADD4C8993F\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Using the Blend Modes</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-29727281-5732-4F89-A06A-BBADD4C8993F\"></a><div class=\"head\">\n            <h1>Using the Blend Modes</h1>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF7B1DE9F8127315F1B54-6019\"></a>The <em class=\"mild\">blend mode</em> specifies how the animation in an animation layer is blended with the animation in\n            the preceding animation layers of the animation stack. The following table explains\n            the blend modes: <a name=\"TABLE_B29EDAE95B204674846A2D06EF3921CC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"20%\">\n                     <col width=\"40%\">\n                     <col width=\"40%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\">Mode </th>\n                     <th class=\"table-heading\">Description </th>\n                     <th class=\"table-heading\">Example </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">Additive </td>\n                     <td class=\"table-body\"> <a name=\"GUID-5624C918-20F8-4865-94F3-AF44588DBE6C\"></a><p class=\"table-body\">The animation layer <em class=\"mild\">adds</em> the animation to the preceding animation layers in the animation stack. The preceding\n                           animation layers must affect the same FBX properties. \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-C5684A0B-F044-4F34-885B-856FDC56744C\"></a><p class=\"table-body\">If AnimLayerA and AnimLayerB both contain animation curve nodes that control the X\n                           translation of a FBX object, the resulting X translation is the sum of the X translation\n                           values in both the animation layers. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\">Override </td>\n                     <td class=\"table-body\"> <a name=\"GUID-6D6F08B9-6C0A-46DD-B956-CED14979BF56\"></a><p class=\"table-body\">The animation layer <em class=\"mild\">overrides</em> the animation in the preceding animation layers of the animation stack. The preceding\n                           animation layers must control the same FBX properties. \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-FABC197B-7DEC-4E2D-811C-C8FF6EA2348F\"></a><p class=\"table-body\">If AnimLayerA and AnimLayerB are in override mode, and the X translation of a FBX\n                           object on AnimLayerA is 10, and on AnimLayerB the X translation is 15, then the resulting\n                           X translation of the FBX object is 15. \n                        </p> \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">Override-Passthrough </td>\n                     <td class=\"table-body\"> <a name=\"GUID-EA8C182C-7A66-4689-B2F7-4D01800CBA08\"></a><p class=\"table-body\">Unlike, the <em class=\"mild\">override</em> mode that completely blocks the animation in the preceding animation layers, in the\n                           <em class=\"mild\">override-passthrough</em> mode, you can control the opacity of the animation layer. The preceding animation\n                           layers must affect the same FBX properties. \n                        </p> \n                     </td>\n                     <td class=\"table-body\"> <a name=\"GUID-A658E7A1-C961-4C9D-8035-8007C235E751\"></a><p class=\"table-body\">If AnimLayerC is in the <em class=\"mild\">override</em> mode, then it is completely opaque and blocks the animation in the preceding animation\n                           layers. However, if AnimLayerC is in the <em class=\"mild\">override-passthrough</em> mode, you can control the opacity of AnimLayerC by setting the <em class=\"mild\">weight</em> value. \n                        </p> \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </p>\n         <div class=\"see-also\">\n            <h4>See Also</h4>\n            <div class=\"related-links\">\n               <ul>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF7B1DE9F8127315F1B54-6010\"></a>enum <span class=\"code\">FbxAnimLayer::EBlendMode</span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF7B1DE9F8127315F1B54-600F\"></a>enum <span class=\"code\">FbxAnimLayer::ERotationAccumulationMode</span> \n                     </p> \n                  </li>\n                  <li> \n                     <p><a name=\"WS1A9193826455F5FF7B1DE9F8127315F1B54-600E\"></a>enum <span class=\"code\">FbxAnimLayer::EScaleAccumulationMode</span> \n                     </p> \n                  </li>\n               </ul>\n            </div>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";