var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-29C09995-47A9-4B49-9535-2F6BDC5C4107\">\n      <meta name=\"description\" content=\"This topic provides a basic overview of your first FBX SDK program.\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Your First FBX SDK Program</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-29C09995-47A9-4B49-9535-2F6BDC5C4107\"></a><div class=\"head\">\n            <h1>Your First FBX SDK Program</h1>\n         </div>\n         <p class=\"blurb\">This topic provides a basic overview of your first FBX SDK program. </p>\n         <p><a name=\"GUID-FE5E8AA6-47FC-4E63-B4F9-E23795D21A90\"></a>This program uses the statically linked version of the FBX SDK. For additional information\n            on how to install and configure the FBX SDK for your environment, see <span class=\"char_link\"><a href=\"GUID-063B70C4-CADC-42B5-9DCC-55274A8B0837.htm\">Installing and Configuring</a></span>. \n         </p>\n         <p><a name=\"GUID-8F98A243-C0EF-4F99-8055-3810934C0F59\"></a>The following FBX SDK program provides an overview about how to: \n         </p><a name=\"OL_B1A18F30EB5941A6995CD09DEE7B0B46\"></a><ol type=\"1\" start=\"1\">\n            <li>Instantiate an FBX SDK memory management object. (<span class=\"code\">FbxManager</span>) \n            </li>\n            <li>Import the contents of an FBX file into a scene. (<span class=\"code\">FbxIOSettings</span>, <span class=\"code\">FbxImporter</span>, <span class=\"code\">FbxScene</span>) \n            </li>\n            <li>Traverse the element hierarchy of a scene. (<span class=\"code\">FbxScene</span>, <span class=\"code\">FbxNode</span>, <span class=\"code\">FbxNodeAttribute</span>) \n            </li>\n            <li>Access and print basic information about the elements of a scene. (<span class=\"code\">FbxNode</span>, <span class=\"code\">FbxNodeAttribute</span>, <span class=\"code\">FbxString</span>) \n            </li>\n         </ol>\n         <div class=\"section\"><a name=\"SECTION_6D3FB549A016431BB916A825CCFFE4C3\"></a> \n            <h2><a name=\"GUID-B6743C69-B95E-4A48-8843-2FC0FCC0A90D\"></a>Managing Objects\n            </h2> \n            <p><a name=\"GUID-B411A30F-D855-42AA-956A-721C26746A16\"></a> <a name=\"UL_0D74535CD01346B890D72B603CDE76E5\"></a><p class=\"list-intro\"><a name=\"GUID-59905E55-5A52-49EB-AB75-7E04E0C071D7\"></a>Related topics:\n               </p>\n               <ul>\n                  <li> <span class=\"char_link\"><a href=\"GUID-B3BF2A41-2262-4706-ABB3-D3C861B3F03B.htm\">FBX SDK Object Model</a></span> \n                  </li>\n               </ul> \n            </p> \n            <p><a name=\"GUID-896CD06C-B777-46AC-914E-8C2AB7D6E612\"></a>The majority of objects manipulated by the FBX SDK are instantiated with a reference\n               to the SDK\'s memory manager object (<span class=\"code\">FbxManager</span>). It is usually one of the first objects to be created in a program which uses the\n               FBX SDK, and it is instantiated with the <span class=\"code\">FbxManager::Create()</span> function. A program only requires one instance of <span class=\"code\">FbxManager</span>. When an instance of <span class=\"code\">FbxManager</span> is destroyed using the <span class=\"code\">FbxManager::Destroy()</span> method, all the other FBX SDK objects which were created with it are also destroyed.\n               \n            </p> \n            <div class=\"codeBlock\"><pre>#include &lt;fbxsdk.h&gt;\n\n// ...\n\n/**\n * Main function - loads the hard-coded fbx file,\n * and prints its contents in an xml format to stdout.\n */\nint main(int argc, char** argv) {\n\n    // Change the following filename to a suitable filename value.\n    const char* lFilename = \"file.fbx\";\n    \n    // Initialize the SDK manager. This object handles memory management.\n    FbxManager* lSdkManager = FbxManager::Create();</pre></div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_BA6A751148B340C3AF7FFC59C33DBC0F\"></a> \n            <h2><a name=\"GUID-A449E996-61D4-4574-B509-8B560754CB19\"></a>Importing the Contents of an FBX File\n            </h2> \n            <p><a name=\"GUID-ABE94AE0-51A0-4160-913E-EC65080AD0DE\"></a> <a name=\"UL_E706D3C72D6349CBB0DAA07F8BE5D2C7\"></a><p class=\"list-intro\"><a name=\"GUID-B3A8D76F-5E5A-4CA8-9105-A13860F7E3A2\"></a>Related topics:\n               </p>\n               <ul>\n                  <li> <span class=\"char_link\"><a href=\"GUID-0B122E01-7DB8-48E3-AADA-5E85A197FEE1.htm\">Supported File Formats</a></span> \n                  </li>\n                  <li> <span class=\"char_link\"><a href=\"GUID-50489A8A-457C-4B54-80E1-5572A16F7F17.htm\">I/O Settings</a></span> \n                  </li>\n                  <li> <span class=\"char_link\"><a href=\"GUID-ABFC58F1-C10D-42AE-A204-D79EB1D84B24.htm\">Importing a Scene</a></span> \n                  </li>\n               </ul> \n            </p> \n            <p><a name=\"GUID-79A28AF9-B182-4726-8867-9DF694621856\"></a>To import the contents of an FBX file, a <span class=\"code\">FbxIOSettings</span> object and a <span class=\"code\">FbxImporter</span> object must be created. A <span class=\"code\">FbxImporter</span> object is initialized by providing the filename of the file to import along with\n               a <span class=\"code\">FbxIOSettings</span> object that has been appropriately configured to suit the importing needs (see <span class=\"char_link\"><a href=\"GUID-50489A8A-457C-4B54-80E1-5572A16F7F17.htm\">I/O Settings</a></span>). \n            </p> \n            <div class=\"codeBlock\"><pre>// Create the IO settings object.\n    FbxIOSettings *ios = FbxIOSettings::Create(lSdkManager, IOSROOT);\n    lSdkManager-&gt;SetIOSettings(ios);\n\n    // Create an importer using the SDK manager.\n    FbxImporter* lImporter = FbxImporter::Create(lSdkManager,\"\");\n    \n    // Use the first argument as the filename for the importer.\n    if(!lImporter-&gt;Initialize(lFilename, -1, lSdkManager-&gt;GetIOSettings())) { \n        printf(\"Call to FbxImporter::Initialize() failed.\\n\"); \n        printf(\"Error returned: %s\\n\\n\", lImporter-&gt;GetStatus().GetErrorString()); \n        exit(-1);</pre></div> \n            <p><a name=\"GUID-05910612-ABE1-49F1-AA19-040EFD0BE26F\"></a>The <span class=\"code\">FbxImporter</span> object populates a provided <span class=\"code\">FbxScene</span> object with the elements contained in the FBX file. Observe that an empty string\n               is passed as the second parameter in the <span class=\"code\">FbxScene::Create()</span> function. Objects created in the FBX SDK can be given arbitrary, non-unique names,\n               that allow the user or other programs to identify the object after it is exported.\n               After the <span class=\"code\">FbxScene</span> is populated, the <span class=\"code\">FbxImporter</span> can be safely destroyed. \n            </p> \n            <div class=\"codeBlock\"><pre>// Create a new scene so that it can be populated by the imported file.\n    FbxScene* lScene = FbxScene::Create(lSdkManager,\"myScene\");\n\n    // Import the contents of the file into the scene.\n    lImporter-&gt;Import(lScene);\n\n    // The file is imported, so get rid of the importer.\n    lImporter-&gt;Destroy();</pre></div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_91D5A8247265437DBDBB610EEC784476\"></a> \n            <h2><a name=\"GUID-E5E788D6-A3D3-4F26-B219-5320EBE4E3C2\"></a>Exploring the Scene\n            </h2> \n            <p><a name=\"GUID-37189B33-331C-4D06-890E-98EE2ACBAC2E\"></a> <a name=\"UL_3422DDCD87BD43ABB2316D362899CFDA\"></a><p class=\"list-intro\"><a name=\"GUID-64991D5A-227E-471C-8B83-0FC425637ABA\"></a>Related topics:\n               </p>\n               <ul>\n                  <li> <span class=\"char_link\"><a href=\"GUID-4F644045-380D-4B75-A2A3-D39DDE53BEDD.htm\">FBX Scenes</a></span> \n                  </li>\n                  <li> <span class=\"char_link\"><a href=\"GUID-02CF7021-71FF-4F31-A072-291EF86CCA5A.htm\">FBX Nodes</a></span> \n                  </li>\n                  <li> <span class=\"char_link\"><a href=\"GUID-FCD71AFF-F753-4D58-B96E-453ED84BF5C4.htm\">FBX Node Attributes</a></span> \n                  </li>\n                  <li> <span class=\"char_link\"><a href=\"GUID-C08BAE05-B074-441C-9DBE-CE1811C0E6E2.htm\">Merging Two Scenes</a></span> \n                  </li>\n               </ul> \n            </p> \n            <p><a name=\"GUID-CD8D4D4C-9B92-478C-BD37-30D34F7B62B1\"></a>The <span class=\"code\">FbxScene</span> object acts as a container for elements existing within the scene. Observe that there\n               can only be one <span class=\"code\">FbxScene</span> object per imported or exported file. A scene can contain a variety of elements including:\n               meshes, lights, cameras, skeletons, and NURBS (to name a few). The elements of a <span class=\"code\">FbxScene</span> are organized in a hierarchical tree of <span class=\"code\">FbxNodes</span>. The root node of a scene is accessed through <span class=\"code\">FbxScene::GetRootNode()</span>. The root node of a scene is not saved when the scene is exported to a file; only\n               its children are saved. The children of a node can be accessed through <span class=\"code\">FbxNode::GetChild()</span>. Similarly, the parent of a node can be accessed through <span class=\"code\">FbxNode::GetParent()</span>. Conceptually, a <span class=\"code\">FbxNode</span> acts as a container for one or more scene elements. For example, one <span class=\"code\">FbxNode</span> in the scene can contain a camera, whereas another <span class=\"code\">FbxNode</span> can contain a mesh. In the FBX SDK, scene elements such as meshes, lights, cameras,\n               skeletons, nurbs, animation curves, and so on are defined by classes derived from\n               <span class=\"code\">FbxNodeAttribute</span>. There can be more than one <span class=\"code\">FbxNodeAttribute</span> per <span class=\"code\">FbxNode</span>. \n            </p> \n            <div class=\"codeBlock\"><pre>    // Print the nodes of the scene and their attributes recursively.\n    // Note that we are not printing the root node because it should\n    // not contain any attributes.\n    FbxNode* lRootNode = lScene-&gt;GetRootNode();\n    if(lRootNode) {\n        for(int i = 0; i &lt; lRootNode-&gt;GetChildCount(); i++)\n            PrintNode(lRootNode-&gt;GetChild(i));\n    }\n    // Destroy the SDK manager and all the other objects it was handling.\n    lSdkManager-&gt;Destroy();</pre></div> \n            <p><a name=\"GUID-5E3D051F-2F98-4503-83DA-2561E34E78C8\"></a>An <span class=\"code\">FbxNode</span> provides access to its local translation (<span class=\"code\">FbxNode::LclTranslation</span>), rotation (<span class=\"code\">FbxNode::LclRotation</span>), and scaling (<span class=\"code\">FbxNode::LclScaling</span>) properties. These properties represent the transformations applied to the parent\n               node\'s position, orientation, and scale to obtain the current node\'s position, orientation,\n               and scale. \n            </p> \n            <div class=\"codeBlock\"><pre>/**\n * Print a node, its attributes, and all its children recursively.\n */\nvoid PrintNode(FbxNode* pNode) {\n    PrintTabs();\n    const char* nodeName = pNode-&gt;GetName();\n    FbxDouble3 translation = pNode-&gt;LclTranslation.Get(); \n    FbxDouble3 rotation = pNode-&gt;LclRotation.Get(); \n    FbxDouble3 scaling = pNode-&gt;LclScaling.Get();\n\n    // Print the contents of the node.\n    printf(\"&lt;node name=\'%s\' translation=\'(%f, %f, %f)\' rotation=\'(%f, %f, %f)\' scaling=\'(%f, %f, %f)\'&gt;\\n\", \n        nodeName, \n        translation[0], translation[1], translation[2],\n        rotation[0], rotation[1], rotation[2],\n        scaling[0], scaling[1], scaling[2]\n        );\n    numTabs++;\n\n    // Print the node\'s attributes.\n    for(int i = 0; i &lt; pNode-&gt;GetNodeAttributeCount(); i++)\n        PrintAttribute(pNode-&gt;GetNodeAttributeByIndex(i));\n\n    // Recursively print the children.\n    for(int j = 0; j &lt; pNode-&gt;GetChildCount(); j++)\n        PrintNode(pNode-&gt;GetChild(j));\n\n    numTabs--;\n    PrintTabs();\n    printf(\"&lt;/node&gt;\\n\");\n}</pre></div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_36084DC3FFA84811BC4EAF714C54AE73\"></a> \n            <h2><a name=\"GUID-BEBA36C6-934D-490B-AAA8-EC7C48B28784\"></a>Your First Program\n            </h2> \n            <div class=\"codeBlock\"><pre>#include &lt;fbxsdk.h&gt;\n\n/* Tab character (\"\\t\") counter */\nint numTabs = 0; \n\n/**\n * Print the required number of tabs.\n */\nvoid PrintTabs() {\n    for(int i = 0; i &lt; numTabs; i++)\n        printf(\"\\t\");\n}\n\n/**\n * Return a string-based representation based on the attribute type.\n */\nFbxString GetAttributeTypeName(FbxNodeAttribute::EType type) { \n    switch(type) { \n        case FbxNodeAttribute::eUnknown: return \"unidentified\"; \n        case FbxNodeAttribute::eNull: return \"null\"; \n        case FbxNodeAttribute::eMarker: return \"marker\"; \n        case FbxNodeAttribute::eSkeleton: return \"skeleton\"; \n        case FbxNodeAttribute::eMesh: return \"mesh\"; \n        case FbxNodeAttribute::eNurbs: return \"nurbs\"; \n        case FbxNodeAttribute::ePatch: return \"patch\"; \n        case FbxNodeAttribute::eCamera: return \"camera\"; \n        case FbxNodeAttribute::eCameraStereo: return \"stereo\"; \n        case FbxNodeAttribute::eCameraSwitcher: return \"camera switcher\"; \n        case FbxNodeAttribute::eLight: return \"light\"; \n        case FbxNodeAttribute::eOpticalReference: return \"optical reference\"; \n        case FbxNodeAttribute::eOpticalMarker: return \"marker\"; \n        case FbxNodeAttribute::eNurbsCurve: return \"nurbs curve\"; \n        case FbxNodeAttribute::eTrimNurbsSurface: return \"trim nurbs surface\"; \n        case FbxNodeAttribute::eBoundary: return \"boundary\"; \n        case FbxNodeAttribute::eNurbsSurface: return \"nurbs surface\"; \n        case FbxNodeAttribute::eShape: return \"shape\"; \n        case FbxNodeAttribute::eLODGroup: return \"lodgroup\"; \n        case FbxNodeAttribute::eSubDiv: return \"subdiv\"; \n        default: return \"unknown\"; \n    } \n}\n\n/**\n * Print an attribute.\n */\nvoid PrintAttribute(FbxNodeAttribute* pAttribute) {\n    if(!pAttribute) return;\n \n    FbxString typeName = GetAttributeTypeName(pAttribute-&gt;GetAttributeType());\n    FbxString attrName = pAttribute-&gt;GetName();\n    PrintTabs();\n    // Note: to retrieve the character array of a FbxString, use its Buffer() method.\n    printf(\"&lt;attribute type=\'%s\' name=\'%s\'/&gt;\\n\", typeName.Buffer(), attrName.Buffer());\n}\n\n/**\n * Print a node, its attributes, and all its children recursively.\n */\nvoid PrintNode(FbxNode* pNode) {\n    PrintTabs();\n    const char* nodeName = pNode-&gt;GetName();\n    FbxDouble3 translation = pNode-&gt;LclTranslation.Get(); \n    FbxDouble3 rotation = pNode-&gt;LclRotation.Get(); \n    FbxDouble3 scaling = pNode-&gt;LclScaling.Get();\n\n    // Print the contents of the node.\n    printf(\"&lt;node name=\'%s\' translation=\'(%f, %f, %f)\' rotation=\'(%f, %f, %f)\' scaling=\'(%f, %f, %f)\'&gt;\\n\", \n        nodeName, \n        translation[0], translation[1], translation[2],\n        rotation[0], rotation[1], rotation[2],\n        scaling[0], scaling[1], scaling[2]\n        );\n    numTabs++;\n\n    // Print the node\'s attributes.\n    for(int i = 0; i &lt; pNode-&gt;GetNodeAttributeCount(); i++)\n        PrintAttribute(pNode-&gt;GetNodeAttributeByIndex(i));\n\n    // Recursively print the children.\n    for(int j = 0; j &lt; pNode-&gt;GetChildCount(); j++)\n        PrintNode(pNode-&gt;GetChild(j));\n\n    numTabs--;\n    PrintTabs();\n    printf(\"&lt;/node&gt;\\n\");\n}\n\n/**\n * Main function - loads the hard-coded fbx file,\n * and prints its contents in an xml format to stdout.\n */\nint main(int argc, char** argv) {\n\n    // Change the following filename to a suitable filename value.\n    const char* lFilename = \"file.fbx\";\n    \n    // Initialize the SDK manager. This object handles all our memory management.\n    FbxManager* lSdkManager = FbxManager::Create();\n    \n    // Create the IO settings object.\n    FbxIOSettings *ios = FbxIOSettings::Create(lSdkManager, IOSROOT);\n    lSdkManager-&gt;SetIOSettings(ios);\n\n    // Create an importer using the SDK manager.\n    FbxImporter* lImporter = FbxImporter::Create(lSdkManager,\"\");\n    \n    // Use the first argument as the filename for the importer.\n    if(!lImporter-&gt;Initialize(lFilename, -1, lSdkManager-&gt;GetIOSettings())) { \n        printf(\"Call to FbxImporter::Initialize() failed.\\n\"); \n        printf(\"Error returned: %s\\n\\n\", lImporter-&gt;GetStatus().GetErrorString()); \n        exit(-1); \n    }\n    \n    // Create a new scene so that it can be populated by the imported file.\n    FbxScene* lScene = FbxScene::Create(lSdkManager,\"myScene\");\n\n    // Import the contents of the file into the scene.\n    lImporter-&gt;Import(lScene);\n\n    // The file is imported; so get rid of the importer.\n    lImporter-&gt;Destroy();\n    \n    // Print the nodes of the scene and their attributes recursively.\n    // Note that we are not printing the root node because it should\n    // not contain any attributes.\n    FbxNode* lRootNode = lScene-&gt;GetRootNode();\n    if(lRootNode) {\n        for(int i = 0; i &lt; lRootNode-&gt;GetChildCount(); i++)\n            PrintNode(lRootNode-&gt;GetChild(i));\n    }\n    // Destroy the SDK manager and all the other objects it was handling.\n    lSdkManager-&gt;Destroy();\n    return 0;\n}\n</pre></div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";