var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-3DC64450-58B7-45D6-B7DD-F18190C247DB\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Migrating to the New Data Structures for Animation</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3DC64450-58B7-45D6-B7DD-F18190C247DB\"></a><div class=\"head\">\n            <h1>Migrating to the New Data Structures for Animation</h1>\n         </div>\n         <p><a name=\"WS73099CC142F48755-191A86AC126720FA35435D7\"></a>The current FBX SDK animation system is completely redesigned. The data structures\n            in FBX SDK 2010 such as take node, take node container, take info, and others have\n            been replaced with new data structures. The following table explains the differences\n            between the current data structures and the data structures in FBX SDK 2010. \n         </p><a name=\"WS73099CC142F48755-191A86AC126720FA35435D9\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"28.57142857142857%\">\n                  <col width=\"28.57142857142857%\">\n                  <col width=\"42.857142857142854%\">\n               </colgroup>\n               <tr class=\"ruled-heading\">\n                  <th class=\"table-heading\">Deprecated class and Data Structure </th>\n                  <th class=\"table-heading\">Current Data Structure and Class </th>\n                  <th class=\"table-heading\">Difference </th>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <span class=\"code\">KFbxTake</span>class, Take, Current Take \n                  </td>\n                  <td class=\"table-body\">Animation Stack (<span class=\"code\">FbxAnimStack</span>) \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF5BB0A1A512649144CFC-7CB4\"></a><p class=\"table-body\">The animation stack replaces the concept of <em class=\"mild\">take</em> as the highest-level container for animation. \n                     </p> <a name=\"GUID-7CE2AB49-0B40-473A-9090-845C21EFB63A\"></a><p class=\"table-body\">A scene can contain one or more animation stacks. Instead of multiple takes in a scene,\n                        now you can use multiple animation stacks. You do not need to use animation stacks\n                        or other animation classes if there is no animation in the scene. \n                     </p> <a name=\"GUID-B53640DA-60A3-4C97-A6D2-E25AAA4D0168\"></a><p class=\"table-body\"> The current <span class=\"code\">FbxAnimStack</span> class manages the same data as the deprecated <span class=\"code\">KFbxTake</span> class. \n                     </p> <a name=\"WS73099CC142F48755-191A86AC126720FA35435DA\"></a><p class=\"table-body\">An animation stack can contain one or more animation layers. </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <span class=\"code\">KFbxTakeNode</span> \n                  </td>\n                  <td class=\"table-body\">No equivalent data structure in current SDK </td>\n                  <td class=\"table-body\" align=\"center\" valign=\"middle\">— </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\">No equivalent class or data structure </td>\n                  <td class=\"table-body\">Animation Layer (<span class=\"code\">FbxAnimLayer</span>) \n                  </td>\n                  <td class=\"table-body\"> <a name=\"GUID-4C5D2E7B-B630-4485-8DA1-AE669479E1E9\"></a><p class=\"table-body\">An animation layer contains one or more <em class=\"mild\"> animation curve nodes</em> that are connected to the <em class=\"mild\">animation curves</em>. The animation stack must have at least one animation layer known as the base layer.\n                        For blended animation, more than one animation layer is required. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <span class=\"code\">KFCurve</span> \n                  </td>\n                  <td class=\"table-body\">Animation Curves (<span class=\"code\">FbxAnimCurve</span>) \n                  </td>\n                  <td class=\"table-body\"> <a name=\"GUID-0BAB4772-2EC8-474B-AC63-7F0A75E9E8B5\"></a><p class=\"table-body\">An animation curve, also known as function curve or FCurve defines how a FBX property\n                        (<span class=\"code\">FbxProperty</span>) of a FBX object is animated or different from the default value in the animation\n                        layer. The animation curves are connected to the animation curve nodes. \n                     </p> <a name=\"GUID-7F436BA9-3E0A-4BB7-9DA9-7652D7C2A512\"></a><p class=\"table-body\">The <span class=\"code\">FbxAnimCurve</span> class has similar interface as the <span class=\"code\">KFCurve</span> class. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\"> <span class=\"code\">KFCurveNode</span> \n                  </td>\n                  <td class=\"table-body\">Animation Curve Node (<span class=\"code\">FbxAnimCurveNode</span>) \n                  </td>\n                  <td class=\"table-body\"> <a name=\"WS73099CC142F48755-191A86AC126720FA35439DD\"></a><p class=\"table-body\">An animation curve node is the connection point between the animation curves and the\n                        FBX properties. To connect an animation curve to an FBX property, you can connect\n                        the animation curve and the FBX property to one animation curve node. An animation\n                        curve node can be connected to only one FBX property of one FBX object. \n                     </p> <a name=\"WS73099CC142F48755-191A86AC126720FA3543F79\"></a><p class=\"table-body\">The <span class=\"code\">FbxAnimCurveNode</span> class is simpler than <span class=\"code\">KFCurveNode</span> class because hierarchies are not needed. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\"> <span class=\"code\">FbxNode::GetGlobalFromCurrentTakeNode</span> function and similar functions that <span class=\"code\">FbxNode</span> and other classes inherited from <span class=\"code\">KFbxTakeNodeContainer</span> \n                  </td>\n                  <td class=\"table-body\">Evaluator (<span class=\"code\">FbxAnimEvaluator</span>) \n                  </td>\n                  <td class=\"table-body\">The current evaluation system provides the same behaviour as the previous one, but\n                     is better encapsulated. You can write your own evaluator by deriving from the <span class=\"code\">FbxAnimEvaluator</span> class. See <span class=\"char_link\"><a href=\"GUID-D6A250C3-1014-4FAF-AB0A-5EC21B14A055.htm\">Writing and Using your Own Evaluator</a></span>. \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <p><a name=\"WS73099CC142F48755-191A86AC126720FA35439DE\"></a> \n            <div><a name=\"GUID-356E29E1-3234-4335-9408-4939163118AE\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Using the deprecated classes and API elements is not recommended. The compiler may\n                  display warnings when using the deprecated classes and API elements. \n               </div>\n            </div> \n         </p>\n         <div class=\"section\"><a name=\"SECTION_5BCD523600BD4CF08FE2440D5C95E8CD\"></a> \n            <h2><a name=\"GUID-662D10B8-4FB9-4D7E-B4CA-CE4826F9981D\"></a>Exceptions\n            </h2> \n            <p><a name=\"GUID-E23BC6CB-602B-4FC2-99D1-9BECF9F383CB\"></a>The <span class=\"code\">FbxTakeInfo</span> object is not deprecated in the current FBX SDK release. \n            </p> <a name=\"WS1A9193826455F5FF45564F421269B08A8E9-56AF\"></a><ul>\n               <li> You can still retrieve animation data from an FBX file (scene) into <span class=\"code\">FbxTakeInfo</span> objects without loading the entire FBX file. See <span class=\"char_link\"><a href=\"GUID-9481A726-315C-4A58-A347-8AC95C2AF0F2.htm\">Extracting the Animation Data from a FBX File</a></span>. \n               </li>\n               <li>You can initialize a <span class=\"code\">FbxAnimStack</span> object with the data stored in a <span class=\"code\">FbxTakeInfo</span> object. See <span class=\"code\">FbxAnimStack::Reset()</span>. \n               </li>\n            </ul> \n         </div>\n         <div class=\"related-links\">\n            <h4 class=\"related\">Related Links</h4>\n            <ul>\n               <li><span class=\"char_link\"><a href=\"GUID-386BAD6A-82F9-4148-BD5F-3FE2E90A87D0.htm\">Animation Classes and their Interrelationships </a></span></li>\n               <li><span class=\"char_link\"><a href=\"GUID-E7B43ABC-7F96-4A75-8769-3B7574F768AB.htm\">Scene Showing Interrelationships among Data Structures </a></span></li>\n            </ul>\n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";