var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-3DE46B9A-A7EE-403E-866B-427B800F9F9D\">\n      <meta name=\"indexterm\" content=\"SceneTreeView: project organization\">\n      <meta name=\"indexterm\" content=\"tutorials: traversing the scene graph\">\n      <meta name=\"indexterm\" content=\"scene graph: traversing\">\n      <meta name=\"indexterm\" content=\"graph: traversing scene\">\n      <meta name=\"indexterm\" content=\"graph: traversing scene\">\n      <meta name=\"indexterm\" content=\"SceneTreeView: main logic\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Tutorial: SceneTreeView</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-3DE46B9A-A7EE-403E-866B-427B800F9F9D\"></a><div class=\"head\">\n            <h1>Tutorial: SceneTreeView</h1>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6B33\"></a>Shows how to traverse all the nodes in an FBX scene, and how to determine the content\n            of each node, i.e., whether a node contains a camera, a light, a mesh, etc. For more\n            information, see <span class=\"char_link\"><a href=\"GUID-F194000D-5AD4-49C1-86CC-5DAC2CE64E97.htm#WS8E4C2438B09B7F9C-5FE157071197CCD9B09-8000\">Nodes and the Scene Graph</a></span>. \n         </p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6B32\"></a><p class=\"list-intro\"><a name=\"GUID-05E85D78-9A72-4F63-A37E-90A8A269A04A\"></a>Operations include:\n         </p>\n         <ul>\n            <li>Getting a reference to the root node of a scene. </li>\n            <li>Getting references to each of the child nodes. </li>\n            <li>Getting references in both directions of a two-way relationship. </li>\n            <li>Getting a node’s properties as a point in space. </li>\n            <li>Getting a node’s attribute type and contents. </li>\n         </ul>\n         <div><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6B2C\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Builds and runs on Windows only. \n            </div>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_5DCA75A4F775401BAEC8FAAB4BD18A3B\"></a> \n            <h2><a name=\"GUID-AD11EDF7-9FD9-45E7-916D-48548A785938\"></a>Project Organization\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6A4E\"></a> The SceneTreeView project is located at <span class=\"code\"><em class=\"mild\">&lt;yourFBXSDKpath&gt;</em>\\examples\\UI&nbsp;Examples\\SceneTreeView\\</span>. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6A4C\"></a>SceneTreeView has two source files: \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6A4B\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"50%\">\n                     <col width=\"50%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\">Source file </th>\n                     <th class=\"table-heading\">Description </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">SDK_Utility.cxx </td>\n                     <td class=\"table-body\">Contains platform-independent code that calls FBX SDK to create the scene, import\n                        the file, retrieve data from each node in the scene graph, and add materials, textures,\n                        and animation to the cubes. This tutorial explains much of the code in this file.\n                        \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\">UI.cxx </td>\n                     <td class=\"table-body\">Contains the code that interacts with the user and with Windows, and traverses the\n                        scene graph to display the tree view of the scene. The code contains some calls to\n                        FBX SDK. \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_75022D3423D04CE29BAB0155C3DC14E2\"></a> \n            <h2><a name=\"GUID-EDB288E0-01CD-4CF3-B61A-8033C605C408\"></a>User Interface\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6A53\"></a> The SceneTreeView sample program imports an FBX file into an empty scene, then displays\n               the scene graph. The scene graph is more precisely a tree, also called a node hierarchy.\n               \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6A51\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-FDB1B8DE-5F4D-4973-9D9B-7647ECFE37EA-low.png\"></div> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6A50\"></a>The nodes of the tree refer to the scene elements—the cameras, lights, meshes, skeletons,\n               NURBS, and so forth—that were imported from the FBX file. To display this tree, SceneTreeView\n               must traverse the entire tree, that is, it must visit each node. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_8E868DA5F2374EAEB0F0A83C3A6074CC\"></a> \n            <h2><a name=\"GUID-79870DD7-AE21-45F2-9E4C-145B8C015360\"></a>Main Logic\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6A48\"></a> SceneTreeView logic: \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6A46\"></a><ul>\n               <li>Accepts from the user interface the name and path of the file to be imported. </li>\n               <li>Loads the import file into the scene. </li>\n               <li>Gets a reference to the root node of the scene. </li>\n            </ul> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6A42\"></a>Starting with the root node, SceneTreeView traverses the tree recursively. At each\n               node, SceneTreeView: \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6A41\"></a><ul>\n               <li>Displays the name and attribute type of the node. </li>\n               <li>Displays selected properties of the node, including properties that are stored in\n                  the node attribute. \n               </li>\n               <li>Gets a reference to each of the children of that node. </li>\n            </ul> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";