var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-403ED27A-3B7B-4EB4-A46D-AC7E9857D43D\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Customizing File Formats</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-403ED27A-3B7B-4EB4-A46D-AC7E9857D43D\"></a><div class=\"head\">\n            <h1>Customizing File Formats</h1>\n         </div>\n         <p><a name=\"GUID-4DB2341D-13E0-4A2F-AD7B-337200E0B5DC\"></a> The file formats supported by the <em class=\"mild\">FBX SDK</em> can be found in <span class=\"char_link\"><a href=\"GUID-0B122E01-7DB8-48E3-AADA-5E85A197FEE1.htm\">Supported File Formats</a></span>. It is possible to customize your own file format for use with the <em class=\"mild\">FBX SDK</em>. For more information, see <span class=\"char_link\"><a href=\"GUID-75CD0DC4-05C8-4497-AC6E-EA11406EAE26.htm\">Customizing File Formats with FBX SDK I/O Plug-ins</a></span>. \n         </p>\n         <div class=\"section\"><a name=\"SECTION_B8942A8187204EBE9D920E3E55F525EA\"></a> \n            <h2><a name=\"GUID-25CF7A05-96B7-4674-9764-F70D20F9B09B\"></a>File I/O Modules\n            </h2> \n            <p><a name=\"GUID-36B334BF-51DD-42E5-95AA-A0FB338815E2\"></a>A <em class=\"mild\">file I/O module</em> is a set of classes which read scene data from a file, and write scene data to a\n               file, using a particular file format. Each format supported by the FBX SDK has its\n               own <em class=\"mild\">writer</em> class subclassed from the <span class=\"code\">FbxWriter</span> class, and <em class=\"mild\">reader</em> class subclassed from the <span class=\"code\">FbxReader </span>class. \n            </p> \n            <p><a name=\"GUID-0CB8AAA8-626D-4BE4-9744-4934EF20F339\"></a>The FBX SDK uses a plug-in architecture to load file I/O modules to read and write\n               to specific file formats. For more information on customizing your own file format\n               and using it with the FBX SDK, see <span class=\"char_link\"><a href=\"GUID-75CD0DC4-05C8-4497-AC6E-EA11406EAE26.htm\">Customizing File Formats with FBX SDK I/O Plug-ins</a></span>. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_FCDD6792130840D58ACB34CFD90C7DB6\"></a> \n            <h2><a name=\"GUID-F358E1F4-80DD-4130-9BAB-6D954675F9E7\"></a>Source Code\n            </h2> \n            <p><a name=\"GUID-4FDC56E4-317F-452D-AA02-FDCC50282F11\"></a>To get you started, the <em class=\"mild\">FBX Extensions SDK</em> provides you with the source code and Visual Studio projects of the FBX file format,\n               the Collada file format, and a sample custom file format. \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6BD9\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"52.50875145857643%\">\n                     <col width=\"47.49124854142357%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\">Directory </th>\n                     <th class=\"table-heading\">Description </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"filePath\">plugins/CustomFbx7Plugin/</span> \n                     </td>\n                     <td class=\"table-body\">FBX file format version 7 reader/writer source code. </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"filePath\">plugins/CustomFbx6Plugin/</span> \n                     </td>\n                     <td class=\"table-body\">FBX file format version 6 reader/writer source code. </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"filePath\">plugins/CustomFbx5Plugin/</span> \n                     </td>\n                     <td class=\"table-body\">FBX file format version 5 reader. </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\"> <span class=\"filePath\">plugins/CustomColladaPlugin/</span> \n                     </td>\n                     <td class=\"table-body\">Collada file format reader/writer source code. </td>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\"> <span class=\"filePath\">plugins/CustomReaderWriterPlugin/</span> \n                     </td>\n                     <td class=\"table-body\">Custom file format reader/writer source code. </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";