var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-42C4206E-B67B-45D0-B783-18C6D5B5CB29\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Using Python FBX with Eclipse</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-42C4206E-B67B-45D0-B783-18C6D5B5CB29\"></a><div class=\"head\">\n            <h1>Using Python FBX with Eclipse</h1>\n         </div>\n         <p><a name=\"GUID-1079D096-B9FE-46CA-ADB1-25CFE77E63A8\"></a>This topic presents a series of steps which allow you to use the Python FBX module\n            (\"<span class=\"code\">fbx</span>\") in Eclipse - a cross-platform integrated development environment (IDE). Python\n            code can be written in any text editor, however Eclipse provides an environment to\n            write, debug, and execute Python code. \n         </p>\n         <div class=\"section\"><a name=\"SECTION_5165A1A0E8E14E34BC39DB886E93E847\"></a> \n            <h2><a name=\"GUID-323B6801-6D0F-434B-981B-B43B74EBF72A\"></a>Installing Python, Java, Eclipse, and PyDev\n            </h2> \n            <div><a name=\"GUID-963312D2-46FF-45C1-983D-950A4C9AAA2C\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The following steps have been tested on Windows 7 x64 using FBX SDK 2013, Python 2.6,\n                  Java JRE 7.4, Eclipse Indigo SR2, and PyDev 2.5.0.2012040618. Some steps may change\n                  depending on your operating system and architecture. \n               </div>\n            </div> <a name=\"OL_7FDC3696DA264D9BACBA867342B00F08\"></a><ol type=\"1\" start=\"1\">\n               <li><em class=\"strong\">Install Python 2.6 or Python 3.1</em> - Since we will be developing Python programs, we will need the appropriate Python\n                  <em class=\"mild\">interpreter</em> to execute our Python code. The Python FBX bindings are compiled and distributed\n                  for Python 2.6 and Python 3.1. <a name=\"OL_F03A4F1255394D72BD43AC28CD808F32\"></a><ol type=\"1\" start=\"1\">\n                     <li>In this topic, we will be working with Python 2.6, which can be obtained at: <a href=\"http://www.python.org/getit/releases/2.6/\" target=\"_blank\">http://www.python.org/getit/releases/2.6/</a>. Make sure you download and install the version which matches your operating system\n                        and architecture. \n                     </li>\n                     <li>Follow the <span class=\"char_link\"><a href=\"GUID-2F3A42FA-4C19-42F2-BC4F-B9EC64EA16AA.htm\">Python FBX installation guide</a></span> to copy the Python FBX bindings into your Python installation\'s <span class=\"filePath\">/site-packages/</span> directory. \n                     </li>\n                  </ol> \n               </li>\n               <li><em class=\"strong\">Install Java</em> - The Eclipse IDE is written in Java, so you will first need to download and install\n                  the latest version of Java. The following address provides the versions of Java according\n                  to each operating system and architecture: <a href=\"http://java.com/en/download/manual.jsp\" target=\"_blank\">http://java.com/en/download/manual.jsp</a>. \n               </li>\n               <li><em class=\"strong\">Install Eclipse</em> - The latest version of the Eclipse IDE is available at <a href=\"http://www.eclipse.org/downloads/\" target=\"_blank\">http://www.eclipse.org/downloads/</a>. <a name=\"OL_99F47C2AA2424A989480A3DD7AF92729\"></a><ol type=\"1\" start=\"1\">\n                     <li>Download the \"<em class=\"strong\">Eclipse Classic</em>\" version whose platform and architecture match your Java installation. \n                     </li>\n                     <li>Once downloaded, you may simply extract the contents of the downloaded .zip file into\n                        the directory of your choosing. For example, extracting to <span class=\"filePath\">C:\\Program Files\\</span> in Windows will create the <span class=\"filePath\">C:\\Program Files\\eclipse</span> folder. \n                     </li>\n                     <li>Run the <span class=\"filePath\">eclipse.exe</span> file to open the Eclipse IDE. You will be prompted to select a location for your\n                        <em class=\"mild\">workspace</em>, which will house your future Eclipse projects. \n                     </li>\n                  </ol> \n               </li>\n               <li><em class=\"strong\">Install the PyDev Eclipse Plug-in</em> - The Eclipse Classic IDE is typically used to write Java programs. To write Python\n                  programs in Eclipse, we will install the <em class=\"mild\">PyDev</em> Eclipse plug-in. This plug-in provides useful features for Python development such\n                  as syntax highlighting, auto-complete, debugging, execution, interpreter selection,\n                  and library/module management. <a name=\"OL_6A651D252378409D9C25D7E6D6C3DEED\"></a><ol type=\"1\" start=\"1\">\n                     <li>With Eclipse open, select <em class=\"strong\">Help &gt; Install New Software</em>. \n                     </li>\n                     <li>In the new window, set the \"<span class=\"code\">Work with</span>\" field to the following url: <span class=\"code\">http://pydev.org/updates</span>, and press the \"<span class=\"code\">Add</span>\" button. This url was obtained from: <a href=\"http://pydev.org/download.html\" target=\"_blank\">http://pydev.org/download.html</a>. \n                     </li>\n                     <li>Set the name of the new repository to \"<span class=\"code\">pydev</span>\", or another arbitrary name. \n                     </li>\n                     <li>The available software table should now include the \"<span class=\"code\">PyDev</span>\", and \"<span class=\"code\">PyDev Mylyn Integration (optional)</span>\" checkboxes. Check the \"<span class=\"code\">PyDev</span>\" checkbox and press the \"<span class=\"code\">Next</span>\" button. \n                     </li>\n                     <li>Proceed with the installation and license review steps and press the \"<span class=\"code\">Finish</span>\" button, which will prompt Eclipse to install the PyDev plug-in. Eclipse will likely\n                        need to restart at the end of the plug-in installation. \n                     </li>\n                  </ol> \n               </li>\n               <li><em class=\"strong\">Setting up a PyDev Project in Eclipse</em> - The first time you create a PyDev project within your workspace, you must perform\n                  the following steps to inform Eclipse of the Python interpreter you want to use. <a name=\"OL_F844910478A14827B70C60F092302B88\"></a><ol type=\"1\" start=\"1\">\n                     <li>With Eclipse open, select <em class=\"strong\">File &gt; New &gt; Project</em>. \n                     </li>\n                     <li>In the <em class=\"strong\">Select a wizard</em> window, expand the \"<span class=\"code\">PyDev</span>\" folder, select \"<span class=\"code\">PyDev Project</span>\", and press \"<span class=\"code\">Next</span>\". \n                     </li>\n                     <li>In the <em class=\"strong\">PyDev Project</em> window, click on the \"<span class=\"charspan-emphasis\"> <span class=\"code\">Please configure an interpreter in the related preferences before proceeding</span> </span>\" link near the bottom of the window. \n                     </li>\n                     <li>In the <em class=\"strong\">Python Interpreters</em> window, press \"<span class=\"code\">New</span>\". <a name=\"OL_95BCFEC564424555AE0D703D64A90563\"></a><ol type=\"1\" start=\"1\">\n                           <li>Enter a name for the Python 2.6 interpreter, for example: \"python26\". </li>\n                           <li>Press \"<span class=\"code\">Browse</span>\" and select the installed Python 2.6 interpreter executable. By default on Windows,\n                              this file can be found at: <span class=\"filePath\">C:\\Python26\\python.exe</span>. Press \"<span class=\"code\">Ok</span>\" to select the interpreter. \n                           </li>\n                           <li>Press \"<span class=\"code\">Ok</span>\" to add the presented folders to the SYSTEM pythonpath. Press \"<span class=\"code\">Ok</span>\" again to exit the current window. \n                           </li>\n                        </ol> \n                     </li>\n                     <li>In the <em class=\"strong\">PyDev Project</em> window, set the <em class=\"strong\">Grammar Version</em> drop-down to <em class=\"strong\">2.6.</em>, and provide a project name, for example: \"<span class=\"code\">myFbxPoject</span>\". Press \"<span class=\"code\">Finish</span>\", and press \"<span class=\"code\">Yes</span>\" to enable the PyDev <em class=\"mild\">perspective</em> in Eclipse. \n                     </li>\n                  </ol> \n               </li>\n            </ol> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_74FC46B4E1F34BBA8E49A85107A03FEF\"></a> \n            <h2><a name=\"GUID-76582C4D-9DCD-4548-844A-A66706C0907B\"></a>Using Python FBX with Eclipse\n            </h2> \n            <p><a name=\"GUID-0EC5A015-B132-44B4-B35E-1B1BF4EDC421\"></a>Now that we have created a new PyDev project, we can get to coding our first Python\n               FBX file: \n            </p> <a name=\"OL_34AE85FF71244D60A322835C4998A75E\"></a><ol type=\"1\" start=\"1\">\n               <li>In Eclipse, right-click on your new project folder, and select <em class=\"strong\">New &gt; PyDev Module</em>. \n               </li>\n               <li>Provide a name for your module, for example: \"myFbxProgram\", and select the \"Module:\n                  Main\" template. You can leave the Package field empty. \n               </li>\n               <li>Pressing \"Finish\" will generate the <span class=\"code\">myFbxProgram.py</span> file within your PyDev project, whose contents resemble the following template: \n                  <div class=\"codeBlock\"><pre>\'\'\'\nCreated on ******\n\n@author: ******\n\'\'\'\n\nif __name__ == \'__main__\':\n    pass</pre></div> \n                  <div><a name=\"GUID-F4EE3D19-BF39-4C62-B3D4-A936CE253C5A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The <span class=\"code\">if __name__ == \'__main__\':</span> statement (and all the code below it) is executed when you right-click and select\n                        <em class=\"strong\">Run As &gt; Python Run</em> on your <span class=\"code\">myFbxProgram.py</span> file. This code can also be debugged by selecting <em class=\"strong\">Debug As &gt; Python Run</em>, which will open the Eclipse debugging perspective. For now, the code will do nothing,\n                        as illustrated by the \"<span class=\"code\">pass</span>\" filler keyword. The code surrounded by the three single-quotes is a multi-line comment.\n                        \n                     </div>\n                  </div> \n               </li>\n               <li>To use the functions provided by the Python FBX bindings, write the following import\n                  statement near the top of the file. Eclipse recognizes this module because it was\n                  copied it into the Python interpreter\'s <span class=\"code\">/site-packages/</span> directory in step 1.2 of the installation above. \n                  <div class=\"codeBlock\"><pre>import fbx</pre></div> \n               </li>\n               <li>We can now add a few lines of code which use the <span class=\"code\">fbx</span> module to create and export a simple scene containing a cubic mesh. Replace the code\n                  currently contained in <span class=\"code\">myFbxProgram.py</span> with the following code. As a brief overview, the code below performs the following\n                  steps: <a name=\"OL_AC0A0AEA4E2E4E4FB50A0DB730AAFDD2\"></a><ol type=\"1\" start=\"1\">\n                     <li>Creates an instance of <span class=\"code\">FbxManager</span>, which is used to instantiate the rest of the FBX-related objects. \n                     </li>\n                     <li>Creates an empty <span class=\"code\">FbxScene</span> using the <span class=\"code\">FbxManager</span>. \n                     </li>\n                     <li>Adds a cube to the scene. <a name=\"OL_CE2A544A958F46D9B79217A5B49A9E52\"></a><ol type=\"1\" start=\"1\">\n                           <li>The cube is positioned in the scene using an instance of <span class=\"code\">FbxNode</span>, which is added as a child to the scene\'s root node. \n                           </li>\n                           <li>The vertices and polygons of the actual mesh are defined in an instance of <span class=\"code\">FbxMesh</span>, which is associated as a <em class=\"mild\">node attribute</em> to the <span class=\"code\">FbxNode</span>. \n                           </li>\n                        </ol> \n                     </li>\n                     <li>Saves the scene to <span class=\"code\">myFbxSaveFile.fbx</span> in the FBX ASCII file format. \n                     </li>\n                  </ol> \n                  <div class=\"codeBlock\"><pre>\'\'\'\n\n myFbxProgram.py\n\n    &gt; Creates a cube in a scene, and saves the scene to \'myFbxSaveFile.fbx\' in ASCII format.\n    \n\'\'\'\n\nimport fbx\n\n# A set of vertices which we will use to create a cube in the scene.\ncubeVertices = [ fbx.FbxVector4( -5, -5,  5 ), # 0 - vertex index.\n                 fbx.FbxVector4(  5, -5,  5 ), # 1\n                 fbx.FbxVector4(  5,  5,  5 ), # 2\n                 fbx.FbxVector4( -5,  5,  5 ), # 3\n                 fbx.FbxVector4( -5, -5, -5 ), # 4\n                 fbx.FbxVector4(  5, -5, -5 ), # 5\n                 fbx.FbxVector4(  5,  5, -5 ), # 6\n                 fbx.FbxVector4( -5,  5, -5 )] # 7\n\n# The polygons (faces) of the cube.\npolygonVertices = [ (  0,  1,  2,  3 ), # Face 1 - composed of the vertex index sequence: 0, 1, 2, and 3.\n                    (  4,  5,  6,  7 ), # Face 2\n                    (  8,  9, 10, 11 ), # Face 3 \n                    ( 12, 13, 14, 15 ), # Face 4\n                    ( 16, 17, 18, 19 ), # Face 5\n                    ( 20, 21, 22, 23 )] # Face 6\n\nsaveFilename = \'myFbxSaveFile.fbx\'\n\n###############################################################\n# Helper Function(s).                                         #\n###############################################################\n\ndef addCube( pScene ):\n    \'\'\' Adds a cubic mesh to the scene. \'\'\'\n    \n    # Obtain a reference to the scene\'s root node.\n    rootNode = pScene.GetRootNode()\n    \n    # Create a new node in the scene.\n    newNode = fbx.FbxNode.Create( pScene, \'myNode\' )\n    rootNode.AddChild( newNode )\n    \n    # Create a new mesh node attribute in the scene, and set it as the new node\'s attribute\n    newMesh = fbx.FbxMesh.Create( pScene, \'myMesh\' )\n    newNode.SetNodeAttribute( newMesh )\n    \n    # Define the new mesh\'s control points. Since we are defining a cubic mesh, \n    # there are 4 control points per face, and there are six faces, for a total\n    # of 24 control points.\n    global cubeVertices \n    newMesh.InitControlPoints( 24 )\n    # Face 1\n    newMesh.SetControlPointAt( cubeVertices[0], 0 )\n    newMesh.SetControlPointAt( cubeVertices[1], 1 )\n    newMesh.SetControlPointAt( cubeVertices[2], 2 ) \n    newMesh.SetControlPointAt( cubeVertices[3], 3 ) \n    # Face 2\n    newMesh.SetControlPointAt( cubeVertices[1], 4 ) \n    newMesh.SetControlPointAt( cubeVertices[5], 5 )  \n    newMesh.SetControlPointAt( cubeVertices[6], 6 ) \n    newMesh.SetControlPointAt( cubeVertices[2], 7 )\n    # Face 3\n    newMesh.SetControlPointAt( cubeVertices[5], 8 )\n    newMesh.SetControlPointAt( cubeVertices[4], 9 )\n    newMesh.SetControlPointAt( cubeVertices[7], 10 )\n    newMesh.SetControlPointAt( cubeVertices[6], 11 )\n    # Face 4\n    newMesh.SetControlPointAt( cubeVertices[4], 12 )\n    newMesh.SetControlPointAt( cubeVertices[0], 13 )\n    newMesh.SetControlPointAt( cubeVertices[3], 14 )\n    newMesh.SetControlPointAt( cubeVertices[7], 15 )\n    # Face 5\n    newMesh.SetControlPointAt( cubeVertices[3], 16 )\n    newMesh.SetControlPointAt( cubeVertices[2], 17 )\n    newMesh.SetControlPointAt( cubeVertices[6], 18 )\n    newMesh.SetControlPointAt( cubeVertices[7], 19 )\n    # Face 6\n    newMesh.SetControlPointAt( cubeVertices[1], 20 )\n    newMesh.SetControlPointAt( cubeVertices[0], 21 )\n    newMesh.SetControlPointAt( cubeVertices[4], 22 )\n    newMesh.SetControlPointAt( cubeVertices[5], 23 )\n    \n    # Now that the control points per polygon have been defined, we can create\n    # the actual polygons within the mesh.\n    global polygonVertices\n    for i in range( 0, len( polygonVertices ) ):\n        \n        newMesh.BeginPolygon( i )\n        \n        for j in range( 0, len( polygonVertices[i] ) ):\n            \n            newMesh.AddPolygon( polygonVertices[i][j] )\n        \n        newMesh.EndPolygon()\n\ndef saveScene( pFilename, pFbxManager, pFbxScene, pAsASCII=False ):\n    \'\'\' Save the scene using the Python FBX API \'\'\'\n    exporter = fbx.FbxExporter.Create( pFbxManager, \'\' )\n    \n    if pAsASCII:\n        #DEBUG: Initialize the FbxExporter object to export in ASCII.\n        asciiFormatIndex = getASCIIFormatIndex( pFbxManager )\n        isInitialized = exporter.Initialize( pFilename, asciiFormatIndex )\n    else:\n        isInitialized = exporter.Initialize( pFilename )\n    \n    if( isInitialized == False ):\n        raise Exception( \'Exporter failed to initialize. Error returned: \' + str( exporter.GetStatus().GetErrorString() ) )\n    \n    exporter.Export( pFbxScene )\n    \n    exporter.Destroy()\n\n\ndef getASCIIFormatIndex( pManager ):\n    \'\'\' Obtain the index of the ASCII export format. \'\'\'\n    # Count the number of formats we can write to.\n    numFormats = pManager.GetIOPluginRegistry().GetWriterFormatCount()\n    \n    # Set the default format to the native binary format.\n    formatIndex = pManager.GetIOPluginRegistry().GetNativeWriterFormat()\n    \n    # Get the FBX format index whose corresponding description contains \"ascii\".\n    for i in range( 0, numFormats ):\n        \n        # First check if the writer is an FBX writer.\n        if pManager.GetIOPluginRegistry().WriterIsFBX( i ):\n            \n            # Obtain the description of the FBX writer.\n            description = pManager.GetIOPluginRegistry().GetWriterFormatDescription( i )\n            \n            # Check if the description contains \'ascii\'.\n            if \'ascii\' in description:\n                formatIndex = i\n                break\n    \n    # Return the file format.\n    return formatIndex\n\n###############################################################\n# Main.                                                       #\n###############################################################\nif __name__ == \'__main__\':\n    \n    # Create the required FBX SDK data structures.\n    fbxManager = fbx.FbxManager.Create()\n    fbxScene = fbx.FbxScene.Create( fbxManager, \'\' )\n    \n    # Add a cube to the scene.\n    addCube( fbxScene )\n    \n    # Save the scene.\n    saveScene( saveFilename, fbxManager, fbxScene, pAsASCII=True )\n    \n    ### CLEANUP ###\n    #\n    # Destroy the fbx manager explicitly, which recursively destroys\n    # all the objects that have been created with it. \n    fbxManager.Destroy()\n    #\n    # Once the memory has been freed, it is good practice to delete\n    # the currently invalid references contained in our variables.\n    del fbxManager, fbxScene\n    #\n    ###############</pre></div> \n               </li>\n               <li>Right-click on the <span class=\"code\">myFbxProgram.py</span> file and select <em class=\"strong\">Run As &gt; Python Run</em> \n               </li>\n               <li>Right-click on the <span class=\"code\">myFbxProject</span> project folder and select <em class=\"strong\">Refresh</em>. You will notice that the <span class=\"code\">myFbxSaveFile.fbx</span> file has been added to your project folder. This file contains the scene produced\n                  by running <span class=\"code\">myFbxProgram.py</span>. \n               </li>\n               <li>Right-click on the <span class=\"code\">myFbxSaveFile.fbx</span> file, and select <em class=\"strong\">Properties</em>. In the <em class=\"strong\">Resource</em> tab, the <span class=\"code\">Location</span> field specifies the path of your newly generated <span class=\"code\">.fbx</span> file. This file can be viewed in any Autodesk program which supports the <span class=\"code\">.fbx</span> file format. \n               </li>\n            </ol> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";