var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-49A795C5-28F1-457A-8C56-73CAD77B9ED9\">\n      <meta name=\"indexterm\" content=\"files: importing\">\n      <meta name=\"indexterm\" content=\"files: converting\">\n      <meta name=\"indexterm\" content=\"files: exporting\">\n      <meta name=\"indexterm\" content=\"tutorials: importing/converting/exporting\">\n      <meta name=\"indexterm\" content=\"ImportExport: project organization\">\n      <meta name=\"indexterm\" content=\"organization, ImportExport project\">\n      <meta name=\"indexterm\" content=\"ImportExport: main logic\">\n      <meta name=\"indexterm\" content=\"main logic, ImportExport\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Tutorial: ImportExport</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-49A795C5-28F1-457A-8C56-73CAD77B9ED9\"></a><div class=\"head\">\n            <h1>Tutorial: ImportExport</h1>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6B41\"></a> The ImportExport tutorial program shows how to convert a file from one file format\n            (FBX binary, FBX ASCII, DAE, etc.) to another. For more information, see <span class=\"char_link\"><a href=\"GUID-B0455682-8B84-41FC-BCAA-D746F032261F.htm#WS8E4C2438B09B7F9C29DFAE1197CCD97EC-8000\">Importing and Exporting a Scene</a></span>. \n         </p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6B40\"></a><p class=\"list-intro\"><a name=\"GUID-260B3B6C-59F1-43AF-95A3-3AC4FC3BEC94\"></a>Operations include:\n         </p>\n         <ul>\n            <li>Building and running a sample program using Visual Studio. </li>\n            <li>Managing memory with SDK Manager. </li>\n            <li>Creating an empty scene. </li>\n            <li>Creating a file importer. </li>\n            <li>Loading the import file into the scene. </li>\n            <li>Creating a file exporter. </li>\n            <li>Specifying the file format of the export file. </li>\n            <li>Specifying whether media are embedded in the export file. </li>\n            <li>Exporting the scene to the export file. </li>\n            <li>Cleaning up and shutting down. </li>\n         </ul>\n         <div><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6B35\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Builds and runs on Windows only. \n            </div>\n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F487553A80943A1216E09FB59-4651\"></a> \n            <h2><a name=\"GUID-B6ECA5E6-DBA7-492B-BB81-7CE7CE332D59\"></a>Project Organization\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6AAD\"></a> The ImportExport project is located at <span class=\"code\"><em class=\"mild\">&lt;yourFBXSDKpath&gt;</em>\\examples\\UI&nbsp;Examples\\importexport\\</span>. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6AAB\"></a>ImportExport has two source files: \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6AAA\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"50%\">\n                     <col width=\"50%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\">Source file </th>\n                     <th class=\"table-heading\">Description </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">ImportExport.cpp </td>\n                     <td class=\"table-body\">Platform-independent functions to convert files from one FBX-supported file format\n                        to another. The function with the main logic is <span class=\"code\">ImportExport()</span>. \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\">UI.cpp </td>\n                     <td class=\"table-body\">User interface to <span class=\"code\">ImportExport()</span>. The user interface code depends on the platform for which you downloaded the FBX\n                        SDK. We won’t look at this source file. \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F487553A80943A1216E09FB59-4650\"></a> \n            <h2><a name=\"GUID-E6235F25-2967-4D47-B036-6CC716F9DB25\"></a>User Interface\n            </h2> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6AB0\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-079F50D6-25AF-440B-9A58-EBF5F828A4CB-low.png\"><p class=\"figure-title\">User interface to ImportExport tutorial program. Messages appear in the large textbox\n                  beside the Execute button.\n               </p>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6A9D\"></a> \n            <h2><a name=\"GUID-D39AE5D2-795D-4833-B55F-6D43AE48C55B\"></a>Main Logic\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6A9C\"></a> ImportExport’s <span class=\"code\">ImportExport()</span> function contains the main logic of the file conversion program. <span class=\"code\">ImportExport()</span>does the following: \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6A9A\"></a><ul>\n               <li>Accepts the following parameters from the calling program (i.e., <span class=\"code\">UI.cpp</span>): <a name=\"WS1A9193826455F5FF2566FFD511FF6F8C7CA-657B\"></a><ul>\n                     <li>The path and name of the file to be imported; </li>\n                     <li>The name and path of the file to be exported; </li>\n                     <li>The file format for the file to be exported. </li>\n                  </ul> \n               </li>\n               <li>Creates an SDK manager object to manage the memory used by other FBX objects. </li>\n               <li>Creates a scene object to hold the data from the import file. </li>\n               <li>Creates an importer object to load the file into the scene. </li>\n               <li>Loads the data from the import file into the scene. </li>\n               <li>Saves the data from the scene to the export file. </li>\n               <li>Destroys the SDK manager, which makes sure that all FBX objects are destroyed, i.e.,\n                  that all memory used by the SDK is released. \n               </li>\n               <li>Returns control to the calling program. </li>\n            </ul> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";