var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-5FAF6FE0-5904-45C3-915A-DB0C9586D45B\">\n      <meta name=\"description\" content=\"This topic presents how to customize or extend the features of the FBX SDK.\">\n      <meta name=\"indexterm\" content=\"FBX SDK: customizing\">\n      <meta name=\"indexterm\" content=\"customizing FBX SDK\">\n      <meta name=\"indexterm\" content=\"extending FBX SDK\">\n      <meta name=\"indexterm\" content=\"object types, custom\">\n      <meta name=\"indexterm\" content=\"data types, custom\">\n      <meta name=\"indexterm\" content=\"user data\">\n      <meta name=\"indexterm\" content=\"custom data types\">\n      <meta name=\"indexterm\" content=\"elements, user data for layer\">\n      <meta name=\"indexterm\" content=\"user data: for layer elements\">\n      <meta name=\"indexterm\" content=\"custom data types: for layer elements\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Customizing the FBX SDK</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-5FAF6FE0-5904-45C3-915A-DB0C9586D45B\"></a><div class=\"head\">\n            <h1>Customizing the FBX SDK</h1>\n         </div>\n         <p class=\"blurb\">This topic presents how to customize or extend the features of the FBX SDK. </p>\n         <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-68FE\"></a>  \n         </p>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF4E544F0312754F1F577-7CD6\"></a> \n            <h2><a name=\"GUID-32022012-CB12-43D2-A852-9E0A05ABABD6\"></a>Custom User Data\n            </h2> \n            <p><a name=\"GUID-20F497BD-55B9-4C8F-AB1B-AD7805DB3248\"></a>Instances of <span class=\"code\">FbxObject</span> and <span class=\"code\">FbxProperty</span> provide a (<span class=\"code\">void*</span>) pointer so you can associate any custom data to that instance: <a name=\"UL_0C93697EC62147968D3D333937279DB8\"></a><ul>\n                  <li><em class=\"strong\"> <span class=\"code\">FbxObject</span> </em> user data: <span class=\"code\">FbxObject::SetUserDataPtr()</span>, <span class=\"code\">FbxObject::GetUserDataPtr()</span>. \n                  </li>\n                  <li><em class=\"strong\"> <span class=\"code\">FbxProperty</span> </em> user data: <span class=\"code\">FbxProperty::SetUserDataPtr()</span>, <span class=\"code\">FbxProperty::GetUserDataPtr()</span>. \n                  </li>\n               </ul> \n            </p> \n            <div><a name=\"GUID-66AD4A0D-61B6-4295-9713-F644E787A297\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>You are responsible for creating, destroying, and otherwise managing your custom data.\n                  \n               </div>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-68FC\"></a> \n            <h2><a name=\"GUID-795D7EBC-5B68-479D-8580-1E2781EBEB6D\"></a>Custom Properties\n            </h2> \n            <p><a name=\"GUID-BE0C330F-92D7-4ED3-BAEB-DB7E1F60A361\"></a>Custom instances of <span class=\"code\">FbxProperty</span> can be dynamically added to a <span class=\"code\">FbxObject</span>. The sample code provided in <span class=\"char_link\"><a href=\"GUID-283ED424-E506-4A29-848F-9EAC8F1C4AF9.htm#SECTION_856C0763033E4397A24D646E09F4724C\">FBX Properties</a></span> illustrates how to create and add such custom properties. \n            </p> \n            <p><a name=\"GUID-F960EE3C-5FDA-4FF1-B6D0-E27C60D1480C\"></a>The <span class=\"char_link\"><a href=\"\">ExportScene05</a></span>, <span class=\"char_link\"><a href=\"\">UserProperties</a></span> and <span class=\"char_link\"><a href=\"GUID-49A795C5-28F1-457A-8C56-73CAD77B9ED9.htm\">Tutorial: ImportExport</a></span> sample programs also provide insight on how to get and set data of custom properties.\n               \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-68F8\"></a> \n            <h2><a name=\"GUID-D0409AD0-78A3-456F-BC71-A1804EBBE578\"></a>Custom Classes\n            </h2> \n            <p><a name=\"GUID-7177955D-CC7E-4FB3-BA0A-6FF4D2559B3D\"></a>Custom classes must be registered with the <span class=\"code\">FbxManager</span> by invoking <span class=\"code\">FbxManager::RegisterFbxClass()</span>. \n            </p> \n            <p><a name=\"GUID-4B2F41E2-FBF6-41AC-BC55-F7444B45EF84\"></a>In the following sample taken from <span class=\"code\"><span class=\"char_link\"><a href=\"\">ExportScene03</a></span>/main.cxx</span>, the custom classes <span class=\"code\">MyFbxMesh</span> and <span class=\"code\">MyFbxObject</span> are defined in <span class=\"code\">ExportScene03/MyFbxMesh.h</span>. These classes respectively inherit from <span class=\"code\">FbxMesh</span> and <span class=\"code\">FbxObject</span>. \n            </p> \n            <div class=\"codeBlock\"><pre>#include &lt;fbxsdk.h&gt;\n#include \"../Common/Common.h\"\n#include \"MyFbxMesh.h\"\n\n// ...\n\nint main(int argc, char** argv)\n{\n    FbxManager* lSdkManager = NULL;\n    FbxScene* lScene = NULL;\n    // ...\n\n    // Prepare the FBX SDK.\n    InitializeSdkObjects(lSdkManager, lScene);\n\n    //Add the new class we have created to the Sdk Manager\n    //Our class MyFbxMesh is derived from FbxMesh\n    lSdkManager-&gt;RegisterFbxClass(\"MyFbxMesh\", FBX_TYPE(MyFbxMesh), FBX_TYPE(FbxMesh));\n    //Now, our class MyFbxMesh is ready to be used\n\n    lSdkManager-&gt;RegisterFbxClass(\"MyFbxObject\", FBX_TYPE(MyFbxObject), FBX_TYPE(FbxObject), \"MyFbxObjectType\", \"MyFbxObjectSubType\");\n    // ...\n\n}</pre></div> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-68F5\"></a> \n            <h2><a name=\"GUID-BD133EF3-F475-4395-821E-B022FF41E269\"></a>Custom User Data for Layer Elements\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-68F4\"></a>To create a layer element with a custom type, use the <span class=\"code\">FbxLayerElementUserData</span> class. Like any other layer element, it can be mapped by polygon vertex, by vertex,\n               by polygon, etc. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-68F2\"></a>Refer to the <span class=\"code\">CreateCubeWithMaterialAndMyFbxMesh()</span> function in <span class=\"char_link\"><a href=\"\">ExportScene03</a></span>. This function creates a custom compound based on float and boolean data types, and\n               adds data for each vertex. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-68F1\"></a> \n            <h2><a name=\"GUID-9434AC53-7E44-4050-94D1-94F4C8BD595F\"></a>Custom File Formats\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-68F0\"></a>The FBX SDK imports and exports scene data using several file formats. Each of these\n               file formats has its own <em class=\"mild\">writer</em> class (derived from <span class=\"code\">FbxWriter</span>) and <em class=\"mild\">reader</em> class (derived from <span class=\"code\">FbxReader</span>). To use your custom <span class=\"code\">FbxWriter</span> and <span class=\"code\">FbxReader</span>, they must be loaded by means of an <em class=\"strong\">FBX SDK I/O plug-in</em>. For more information, see <span class=\"char_link\"><a href=\"GUID-75CD0DC4-05C8-4497-AC6E-EA11406EAE26.htm\">Customizing File Formats with FBX SDK I/O Plug-ins</a></span>. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS73099CC142F48755-57AF30D311C79E97FC3D80\"></a> \n            <h2><a name=\"GUID-FC4AD59E-762C-4C80-87B0-88880C5DE66D\"></a>FBX Extensions SDK\n            </h2> \n            <p><a name=\"GUID-A6113DB4-00F4-4E70-9E94-62A2ACD66C04\"></a>The <em class=\"mild\">FBX Extensions SDK </em> is a set of callback functions which you can implement in a <span class=\"filePath\">.dll</span> file. These functions customize the importing and exporting functionality of 3ds\n               Max, Maya and MotionBuilder. For more information, see <span class=\"char_link\"><a href=\"GUID-E03E1C4B-FAD9-4E7B-9BBB-4F6782282402.htm\">FBX Extensions SDK</a></span>. \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";