var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-6CEF4934-120D-4162-87B0-8B30D8032FDB\">\n      <meta name=\"indexterm\" content=\"SceneTreeView: project organization\">\n      <meta name=\"indexterm\" content=\"tutorials: modifying objects\">\n      <meta name=\"indexterm\" content=\"scenes: modifying objects in\">\n      <meta name=\"indexterm\" content=\"objects: modifying in a scene\">\n      <meta name=\"indexterm\" content=\"SceneTreeView: main logic\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Tutorial: CubeCreator</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-6CEF4934-120D-4162-87B0-8B30D8032FDB\"></a><div class=\"head\">\n            <h1>Tutorial: CubeCreator</h1>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6B2A\"></a>This tutorial program shows how to add textures, materials, and animation to meshes\n            representing a model (in this case, a cube). Operations include: \n         </p><a name=\"WS1A9193826455F5FF47B7AA4B11FBE75ECF1-751C\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"40.925756186984415%\">\n                  <col width=\"59.074243813015585%\">\n               </colgroup>\n               <tr class=\"ruled-heading\">\n                  <th class=\"table-heading\">High level operations </th>\n                  <th class=\"table-heading\">Low level operations </th>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\">Constructing the baseline scene </td>\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6B29\"></a><ul>\n                        <li>Defining the animation stack and animation layer that will contain the animation.\n                           \n                        </li>\n                        <li>Creating a marker to be used as a reference point. </li>\n                        <li>Creating a camera. </li>\n                        <li>Creating one texture available to all cubes. </li>\n                        <li>Embedding media files in an FBX file. </li>\n                        <li>Processing FBX files that contain embedded media. </li>\n                        <li>Processing scene files with references to media. </li>\n                        <li>Creating an array of materials to be shared. </li>\n                        <li>Pointing the camera at the marker. </li>\n                        <li>Setting the position of the marker. </li>\n                        <li>Setting the position of the camera. </li>\n                     </ul> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\">Adding animation to the camera </td>\n                  <td class=\"table-body\"> <a name=\"WS1A9193826455F5FF47B7AA4B11FBE75ECF1-751B\"></a><ul>\n                        <li>Constructing the initial scene graph. </li>\n                        <li>Setting a camera as the scene’s default camera. </li>\n                        <li>Adding a cube to the scene. </li>\n                        <li>Setting the cube’s name, position, and rotation. </li>\n                        <li>Applying the user’s specifications to the cube. </li>\n                        <li>Setting the cube’s position in the scene. </li>\n                        <li>Creating a mesh for the cube. </li>\n                        <li>Defining the cube’s vertices and the normals. </li>\n                        <li>Defining the cube’s faces. </li>\n                        <li>Using layer 0 to store a normal to each face. </li>\n                        <li>Creating a layer element for the materials and textures. </li>\n                        <li>Saving memory by sharing a mesh among multiple nodes. </li>\n                        <li>Adding animation to a cube. </li>\n                        <li>Adding a texture to a cube. </li>\n                     </ul> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\">Adding a material to a cube </td>\n                  <td class=\"table-body\">No lower-level operations. </td>\n               </tr>\n            </table>\n         </div>\n         <div><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6B0A\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>Builds and runs on Windows only. \n            </div>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_428FB8159AD042E5AEBD7BA0BADA976C\"></a> \n            <h2><a name=\"GUID-1305DA1B-074D-44D4-A42A-9B3CC8459EF4\"></a>Project Organization\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69EF\"></a> The CubeCreator project is located at <span class=\"code\"><em class=\"mild\">&lt;yourFBXSDKpath&gt;</em>\\examples\\UI&nbsp;Examples\\CubeCreator\\</span>. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69ED\"></a>CubeCreator has two source files: \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69EC\"></a><div class=\"table-ruled\">\n               <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                  <colgroup>\n                     <col width=\"50%\">\n                     <col width=\"50%\">\n                  </colgroup>\n                  <tr class=\"ruled-heading\">\n                     <th class=\"table-heading\">Source file </th>\n                     <th class=\"table-heading\">Description </th>\n                  </tr>\n                  <tr class=\"ruled-odd-row\">\n                     <td class=\"table-body\">SDK_Utility.cxx </td>\n                     <td class=\"table-body\">Contains all the code that calls FBX SDK to create the scene, add the cubes, and add\n                        materials, textures and animation to the cubes.This tutorial explains much of the\n                        code in this file. \n                     </td>\n                  </tr>\n                  <tr class=\"ruled-even-row\">\n                     <td class=\"table-body\">UI.cxx </td>\n                     <td class=\"table-body\">Contains the code that displays the tree view of the scene and that interacts with\n                        the user. The code uses FBX SDK to retrieve the scene data that the UI displays in\n                        its tree view.This tutorial does not explain any of the code in this file. \n                     </td>\n                  </tr>\n               </table>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_B4DEE60C73744879A35D911363668B8E\"></a> \n            <h2><a name=\"GUID-D348AD56-9F72-40FB-8B47-2F48621E1D4D\"></a>User Interface\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69FD\"></a> The CubeCreator sample program shows you how to add textures, materials, and animation\n               to models in a scene. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69FB\"></a>At startup, CubeCreator displays a tree view of a scene containing only a marker and\n               a camera. \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69FA\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-A55230C5-8D51-44B4-8967-39B2BA983952-low.png\"></div> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69F9\"></a>As a user, you can add cubes one at a time to the scene. For each cube, you can opt\n               to: \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69F8\"></a><ul>\n               <li>Add a texture. </li>\n               <li>Add materials. </li>\n               <li>Add an animation. </li>\n            </ul> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69F4\"></a>You can save the scene as an FBX file (or in any file format exported by FBX SDK).\n               \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69F3\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-F9359C15-322F-4523-BE69-05DE4F7DC2C4-low.png\"></div> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69F2\"></a>Here is what <span class=\"code\">8cubes.fbx</span> (the scene shown as a tree, above) looks like when opened in FBX for QuickTime: \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69F1\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-7C9B53EB-6E54-4DC6-8C4C-1E2A12713C34-low.png\"></div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_4DFC9DFC30C24627B55967D84009B9D8\"></a> \n            <h2><a name=\"GUID-62A6BF62-8DA8-4F90-8314-6240F7961F62\"></a>Location of a Texture File at Run Time\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69E9\"></a> <span class=\"code\"> <em class=\"mild\">&lt;yourFBXSDKpath&gt;</em>\\examples\\UI&nbsp;Examples\\CubeCreator\\</span> contains a file named <span class=\"code\">crate.jpg</span>, which CubeCreator uses as a texture file. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69E8\"></a>You must copy this texture file into the folder where the executable for CubeCreator\n               will start. Unless you change the settings for the CubeCreator project: \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69E7\"></a><ul>\n               <li>At build time, <span class=\"code\">CubeCreator.exe</span> will be saved in a subdirectory of <span class=\"code\"><em class=\"mild\">&lt;yourFBXSDKpath&gt;</em>\\bin\\CubeCreator\\</span>. \n               </li>\n               <li>At run time, <span class=\"code\">CubeCreator.exe</span> will execute in that same directory. It will search for the texture file in that\n                  location. \n               </li>\n            </ul> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69E4\"></a>If FBX for QuickTime cannot find a texture file for a surface, it renders the surface\n               as a checkerboard pattern. Here is how that looks for the faces of our cubes: \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69E3\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-E60CE0B6-E88A-4626-88BD-666160ED95EA-low.png\"></div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_25C95513F944435F9A42C37C8662DA3D\"></a> \n            <h2><a name=\"GUID-9B658ECF-1517-4C5A-B21E-8095D19ADC4D\"></a>Main Logic\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69E1\"></a> CubeCreator does the following operations: \n            </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-69DF\"></a><ul>\n               <li>Constructs a baseline scene containing a marker, a camera, and a light. </li>\n               <li>Points the camera at the marker, then adds animation to the camera. The animation\n                  is always the same: a view of the cubes that sweeps back and up. \n               </li>\n               <li>Defines one material that you (the user) can apply to any or all cubes. </li>\n               <li>Defines one texture that you can apply to any or all cubes. </li>\n               <li>Defines animation that you can apply to any or all cubes. If applied to a cube, the\n                  animation causes the cube to rotate around its axis of rotation. \n               </li>\n               <li>Lets you add cubes, one at a time. The cubes are mesh objects. </li>\n               <li>Places the first cube near the marker. </li>\n               <li>Places subsequent cubes alternately: left of and above the leftmost cube, then right\n                  of and above the rightmost cube. \n               </li>\n               <li>Gives each cube an axis of rotation: either X, Y, or Z. </li>\n               <li>Lets you (the user) add 0 to <em class=\"mild\">n</em> cubes. To each cube added, you have the option of adding any or all of a material,\n                  a texture, and animation. \n               </li>\n               <li>Lets you save the scene as an FBX file (or in another FBX-supported file format).\n                  \n               </li>\n               <li>Invites you to use FBX for QuickTime to view and interact with the scene stored in\n                  the saved file. \n               </li>\n            </ul> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";