var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-7AC48DE4-E90E-4F3C-B0E4-17F43C660E91\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Installing the FBX Extensions SDK</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-7AC48DE4-E90E-4F3C-B0E4-17F43C660E91\"></a><div class=\"head\">\n            <h1>Installing the FBX Extensions SDK</h1>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_47768919845047ED8BEF6DAB15551C77\"></a> \n            <h2><a name=\"GUID-F33511B9-6D3E-4691-848C-B89324244956\"></a>Runtime Requirements\n            </h2> \n            <p><a name=\"GUID-BCA97A70-3310-4F84-A1CD-41D54F2D709A\"></a>To run FBX Extensions written with the FBX Extensions SDK, you will need at least\n               one of the following applications installed: <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6BD9\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"52.50875145857643%\">\n                        <col width=\"47.49124854142357%\">\n                     </colgroup>\n                     <tr class=\"ruled-heading\">\n                        <th class=\"table-heading\">Host Application </th>\n                        <th class=\"table-heading\">Supported Platforms </th>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> FBX Plug-in for Maya </td>\n                        <td class=\"table-body\">Windows, Mac OS, Linux </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> FBX Plug-in for 3ds Max </td>\n                        <td class=\"table-body\">Windows </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> MotionBuilder 2012 (or higher) </td>\n                        <td class=\"table-body\">Windows </td>\n                     </tr>\n                  </table>\n               </div> \n            </p> \n            <p><a name=\"GUID-5DA0A7C4-730F-41F3-830F-DF46D2845179\"></a>The FBX Plug-ins for 3ds Max and Maya are available at <a href=\"http://www.autodesk.com/fbx\" target=\"_blank\">http://www.autodesk.com/fbx</a>. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_0BF754B811C74300BD8FA3AA42ACFB80\"></a> \n            <h2><a name=\"GUID-2B9264B7-A22B-4C70-8316-CA0309AFB645\"></a>Downloading and Installing\n            </h2> \n            <div class=\"section\"><a name=\"SECTION_F3493A0D4598408AB5D1A44775DC86CE\"></a> \n               <h3><a name=\"GUID-5A87C721-6F0B-452F-B53B-F65CE7DE5685\"></a>Windows\n               </h3> <a name=\"UL_E63688D7F8AA4435A663F63A8F73A43B\"></a><p class=\"list-intro\"><a name=\"GUID-3EB50429-16DC-45A6-A629-FDC5FD8908EB\"></a>To download and install the FBX Extensions SDK on Windows:\n               </p>\n               <ul>\n                  <li>Go to <a href=\"http://www.autodesk.com/fbx\" target=\"_blank\">http://www.autodesk.com/fbx</a>. \n                  </li>\n                  <li>Navigate to the Downloads page and follow any instructions. </li>\n                  <li>Find the Windows distribution file for the FBX Extensions SDK. </li>\n                  <li>Download the Setup executable file to your computer and run it. </li>\n                  <li>The Setup program will let you specify a destination folder. </li>\n                  <li>Read the provided <span class=\"filePath\">readme.txt</span> file located in the installation folder. \n                  </li>\n               </ul> \n               <div><a name=\"GUID-17DDA387-F5C3-4F1D-BB61-64C123353BCF\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The Setup program modifies the Windows Registry and adds a shortcut to the FBX Extensions\n                     SDK uninstaller in the Windows Start menu. You can have more than one version of the\n                     FBX Extensions SDK installed on your computer, providing you install each version\n                     in a separate folder. \n                  </div>\n               </div> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_908DF0FB70184AFEA8717AEA449D415E\"></a> \n               <h3><a name=\"GUID-57E34E51-FC90-4CC0-BD0D-5C0BB36C428F\"></a>Mac OS and Linux\n               </h3> \n               <p><a name=\"GUID-1DC40AEA-502B-4E04-A4FE-DA986BE82629\"></a>The steps to install the FBX Extensions SDK for Mac OS and Linux are analogous to\n                  the ones detailed in <span class=\"char_link\"><a href=\"GUID-724E9FAD-AFA0-4348-BDAA-6CF2FDF2FF55.htm\">Configuring the FBX SDK for Mac OS</a></span> and <span class=\"char_link\"><a href=\"GUID-408B9928-104E-463E-994D-ACD4CB8341A9.htm\">Configuring the FBX SDK for Linux</a></span> respectively. \n               </p> \n            </div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_B591BCAE8D7A420B90707544E796AF3B\"></a> \n            <h2><a name=\"GUID-078C3E2A-BE76-496F-9AEC-2E365B05AC47\"></a>Directory Structure\n            </h2> \n            <p><a name=\"WS73099CC142F48755-381799D411F6FB5AF15-3CCD\"></a>The structure of the FBX Extensions SDK distribution is very similar to the FBX SDK\n               distribution, and contains many of the same folders. Here are the key differences:\n               \n            </p> <a name=\"WS73099CC142F48755-381799D411F6FB5AF15-3CCC\"></a><ul>\n               <li>Instead of a <span class=\"code\">samples</span> directory, there is a <span class=\"code\">plugins</span> directory. This directory contains: <a name=\"WS73099CC142F48755-381799D411F6FB5AF15-3CCA\"></a><ul>\n                     <li>The actual source code and supporting files for the file I/O module that FBX SDK uses\n                        to support FBX files. \n                     </li>\n                     <li>The actual source code and supporting files for the file I/O module that FBX SDK uses\n                        to support Collada files. \n                     </li>\n                     <li>Source code and supporting files for CustomReaderWriterPlugin, a sample file I/O module\n                        that supports CustomWriter files (a trivial file format used for demonstration purposes).\n                        \n                     </li>\n                  </ul> \n               </li>\n               <li>For Windows: the <span class=\"code\">lib</span> folder contains small <em class=\"mild\">.lib</em> files that link to the appropriate dynamically loaded library file of the FBX Plug-in\n                  for 3ds Max/Maya (which contain the executable code for FBX SDK classes). \n                  <div><a name=\"GUID-30874A81-0BCA-4A8D-A428-AD736B2592DA\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>If you do not intend to use either of these plug-ins, link to the <em class=\"mild\">.lib</em> files distributed with FBX SDK. \n                     </div>\n                  </div> \n               </li>\n               <li>For Maya on Mac OS or Linux: no library files are required to link with the FBX Plug-in\n                  for Maya. Accordingly, there is no <span class=\"code\">lib</span> directory in distributions of the FBX Extensions SDK for Mac OS and Linux. \n               </li>\n            </ul> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";