var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-8A69CD20-B8FB-4B23-925A-372E408390AA\">\n      <meta name=\"description\" content=\"This section presents meshes, textures, and materials in the FBX SDK.\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Meshes, Materials and Textures</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-8A69CD20-B8FB-4B23-925A-372E408390AA\"></a><div class=\"head\">\n            <h1>Meshes, Materials and Textures</h1>\n         </div>\n         <p class=\"blurb\">This section presents meshes, textures, and materials in the FBX SDK. </p>\n         <div class=\"section\"><a name=\"SECTION_6FF8E0E14C4F4714AABE4AA6DCE5FBE0\"></a> \n            <h2><a name=\"GUID-9B93E354-8BF4-4333-8391-F05D2DEA2EFD\"></a>Meshes\n            </h2> \n            <p><a name=\"GUID-F372DC48-577D-4190-A6E9-127053FAF9B6\"></a>Meshes are abstracted by the <span class=\"code\">FbxMesh</span> class. A <span class=\"code\">FbxMesh</span> defines a list of control points, also known in common literature as vertices. A\n               single instance of <span class=\"code\">FbxMesh</span> can be bound to multiple instances of <span class=\"code\">FbxNode</span> to reduce memory consumption. This is known as instancing. Scene geometry uses the\n               concept of layers and layer elements (<span class=\"code\">FbxLayerElement</span>) to define normal maps, material maps, texture maps, etc. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_E95A0F104C0A4654922F661D182A6678\"></a> \n            <h2><a name=\"GUID-E15C89D7-A063-41CB-BAF6-FDD6A7A74FC9\"></a>Materials\n            </h2> \n            <p><a name=\"GUID-7B0C3FCB-A79F-4B5D-A6C3-C5EB06DCEA59\"></a>Materials (<span class=\"code\">FbxSurfaceLambert</span>, <span class=\"code\">FbxSurfacePhong</span>) are bound to instances of <span class=\"code\">FbxNode</span> via <span class=\"code\">FbxNode::AddMaterial()</span>. Materials define the basic rendering characteristics of geometry in the scene, such\n               as its diffuse, ambient, and emissive color properties. Each material occupies a specific\n               index in a <span class=\"code\">FbxNode</span>, which can be referenced by <span class=\"code\">FbxMesh::BeginPolygon()</span> to define the material of a newly created polygon. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_CFA7D2F5D5F44EC9A841A0397F53FE88\"></a> \n            <h2><a name=\"GUID-B8E967A3-AA8F-4320-B151-48FF51680A26\"></a>Textures\n            </h2> \n            <p><a name=\"GUID-A4CEFFC7-3618-4DD5-9944-D937CA14DFF6\"></a>Textures (<span class=\"code\">FbxFileTexture</span>, <span class=\"code\">FbxLayeredTexture</span>, <span class=\"code\">FbxProceduralTexture</span>) are connected to material channels to define how geometry is rendered. The <span class=\"code\">FbxFileTexture</span> class uses data contained in a file, for example a <span class=\"code\">.jpg</span>, to define a texture\'s values. \n            </p> \n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-5EDC0280-E000-4B0B-88DF-5D215A589D5E.htm\">Meshes</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-3E0DCCD0-5F9A-44D0-8D5E-423237D49DB6.htm\">Materials</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-AD69D141-C5DD-4609-AD5A-4805321FADD4.htm\">Textures</a></li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";