var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-963050F3-70DC-448B-BA52-AED9B32B6DEC\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Importing with the FBX Extensions SDK</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-963050F3-70DC-448B-BA52-AED9B32B6DEC\"></a><div class=\"head\">\n            <h1>Importing with the FBX Extensions SDK</h1>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_090AFED57C71427280367F8A2A53C4FE\"></a> \n            <h2><a name=\"GUID-1A87CC88-E628-4C1B-9C48-ACA07012DF36\"></a>Host Application Flow\n            </h2> \n            <p><a name=\"GUID-EE3B565E-64CE-4216-83C8-7EFAC6DFC359\"></a> The following pseudocode shows the order of execution of an FBX Extension while a\n               scene is being imported by the host application. \n            </p> \n            <div class=\"codeBlock\"><pre>At the beginning of the import process:\n    ImportBegin()\n\nFor each object in the scene:\n    If ( ImportHandled() returns TRUE ):\n        The host application will let your extension import/create this object.\n    Else:\n        The host application will import this object.\n\nFor each object translated by the host application:\n    ImportTranslated(), passing the object and its FBX object equivalent.\n\nUpon import process completion:\n    ImportEnd()</pre></div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_BF8F044C42E64D21B5672DFA55B7F9B0\"></a> \n            <h2><a name=\"GUID-9AD85DA6-2F9B-45B3-B697-796EA1B58822\"></a>ImportBegin()\n            </h2> \n            <div class=\"codeBlock\"><pre>EXPORT_DLL void MayaExt_ImportBegin( FbxScene* pFbxScene );\nEXPORT_DLL void MaxExt_ImportBegin( FbxScene* pFbxScene, INode* pMaxRootNode );\nEXPORT_DLL void MBExt_ImportBegin( FbxScene* pFbxScene );</pre></div> \n            <p><a name=\"GUID-ED274AA3-E46B-4963-B0C6-5A203864FE24\"></a> This function is called before the host application imports the scene from the file.\n               This function can be used to act on the FBX scene before it is loaded from the file.\n               \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_BE43EABF00CB464B974C9F373F13AC5F\"></a> \n            <h2><a name=\"GUID-73272BD6-C8B0-4633-B2D8-F3DD12B813AE\"></a>ImportHandled()\n            </h2> \n            <div class=\"codeBlock\"><pre>EXPORT_DLL bool MayaExt_ImportHandled( FbxObject* pFbxObject );\nEXPORT_DLL bool MaxExt_ImportHandled( FbxObject* pFbxObject );\nEXPORT_DLL bool MBExt_ImportHandled( FbxObject* pFbxObject );</pre></div> \n            <p><a name=\"GUID-E5C7BAE9-1173-4D1D-988A-9A8D976309B0\"></a> This function is called by the host application every time it is about to translate\n               the specified FBX object. If your extension should handle its creation, this function\n               returns <span class=\"code\">TRUE</span>. If the host application should instead be responsible of translating the object,\n               this function should return <span class=\"code\">FALSE</span>. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_A22EE74FE9A54205A8CA8C791D31E7C9\"></a> \n            <h2><a name=\"GUID-807D7A6E-B5EF-4C67-A954-0BDED1F491BA\"></a>ImportTranslated()\n            </h2> \n            <div class=\"codeBlock\"><pre>EXPORT_DLL void MayaExt_ImportTranslated( FbxObject* pFbxObject, MObject&amp; pMayaObject );\nEXPORT_DLL void MaxExt_ImportTranslated( FbxObject* pFbxObject, INode* pMaxObject );\nEXPORT_DLL void MBExt_ImportTranslated( FbxObject* pFbxObject, HFBComponent pFBComponent );</pre></div> \n            <p><a name=\"GUID-5D31AD24-76EA-4AD8-87E6-74A81AEBD60C\"></a> This function is called by the host application for each FBX object translated by\n               the host application into its own object format. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_EBB62F1CA793480187509E3D1BB2512D\"></a> \n            <h2><a name=\"GUID-3007212F-173C-43CC-AEF1-A2E4204EDA0F\"></a>ImportEnd()\n            </h2> \n            <div class=\"codeBlock\"><pre>EXPORT_DLL void MayaExt_ImportEnd( FbxScene* pFbxScene );\nEXPORT_DLL void MaxExt_ImportEnd( FbxScene* pFbxScene, INode* pMaxRootNode );\nEXPORT_DLL void MBExt_ImportEnd( FbxScene* pFbxScene );</pre></div> \n            <p><a name=\"GUID-2E98DF53-FE4A-47AC-81EA-CBE6FCDA76F3\"></a> This is called at the end of the import process. \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";