var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-C35D98CB-5148-4B46-82D1-51077D8970EE\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Transformation Data</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-C35D98CB-5148-4B46-82D1-51077D8970EE\"></a><div class=\"head\">\n            <h1>Transformation Data</h1>\n         </div>\n         <div class=\"section\"><a name=\"SECTION_0620EBE099D84E3584B15588C142DC23\"></a> \n            <h2><a name=\"GUID-0123D102-EBE2-43B0-B6E6-6473046FE607\"></a>Translation, Rotation and Scaling Vectors\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF3913A1A412260CA5929-74CD\"></a>The default translation, rotation, and scaling (<em class=\"mild\">default TRS properties</em>) of a node are accessed using the <span class=\"code\">FbxNode::LclTranslation</span>, <span class=\"code\">FbxNode::LclRotation</span>, and <span class=\"code\">FbxNode::LclScaling</span> properties: \n            </p> \n            <div class=\"codeBlock\"><pre>// Get the node’s default TRS properties\nFbxDouble3 lTranslation = lNode-&gt;LclTranslation.Get();\nFbxDouble3 lRotation&nbsp;&nbsp;&nbsp;&nbsp;= lNode-&gt;LclRotation.Get();\nFbxDouble3 lScaling&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;= lNode-&gt;LclScaling.Get();\n</pre></div> \n            <p><a name=\"WS1A9193826455F5FFB5DDF9312711FF81D0-778C\"></a>The <span class=\"code\">FbxTypedProperty</span>All three member functions return vectors of type <span class=\"code\">FbxDouble3</span>. The value of each vector is a triplet of X, Y, and Z coordinates. The value of one\n               of these vectors is an offset from the corresponding default TRS property vector for\n               the parent node. A node’s default TRS properties are therefore <em class=\"mild\">local</em> to the parent node. \n            </p> \n            <p><a name=\"WS1A9193826455F5FF3913A1A412260CA5929-74CC\"></a>The <em class=\"mild\">actual TRS properties</em> for the node at a given point in time depend on: \n            </p> <a name=\"WS1A9193826455F5FF3913A1A412260CA5929-74CB\"></a><ul>\n               <li>The node’s default TRS properties. </li>\n               <li>The <em class=\"mild\">limits</em> that apply to the node (see <span class=\"code\">FbxNode::GetLimits()</span>). \n               </li>\n               <li>The <em class=\"mild\">constraints</em> that apply to the node (see <span class=\"code\">FbxConstraint</span> and its subclasses). \n               </li>\n               <li>The <em class=\"mild\">animation curves</em> of the <em class=\"mild\">current animation stack</em>. For more information, see <span class=\"char_link\"><a href=\"GUID-B3311B8D-5390-4C63-AB9F-662AC7D5C6CC.htm\">Animation</a></span>. \n               </li>\n            </ul> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_225F2405DDBE40B5B461447B0EBBABBA\"></a> \n            <h2><a name=\"GUID-CC64C001-47FD-49F1-AD7C-6D476E2C6B07\"></a>Global and Local Transformation Matrices\n            </h2> \n            <p><a name=\"GUID-577475CB-3A1D-4125-B0BC-ADF49EA11D2A\"></a>A node\'s global and local transformation matrices can be respectively obtained by\n               calling <span class=\"code\">FbxNode::EvaluateGlobalTransform()</span> and <span class=\"code\">FbxNode::EvaluateLocalTransform()</span>: \n            </p> \n            <div class=\"codeBlock\"><pre>// Get the node\'s default global transformation matrix.\nFbxAMatrix&amp; lGlobalTransform = lNode-&gt;EvaluateGlobalTransform();\n\n// Get the node\'s default local transformation matrix.\nFbxAMatrix&amp; lLocalTransform = lNode-&gt;EvaluateLocalTransform();</pre></div> \n            <p><a name=\"GUID-905EDC96-6F8D-424E-8E7B-D5A29E2B33E5\"></a>These member functions are equivalent to using the <span class=\"code\">FbxScene</span>\'s animation evaluator <span class=\"code\">FbxAnimEvaluator::GetNodeGlobalTransform()</span> and <span class=\"code\">FbxAnimEvaluator::GetNodeLocalTransform()</span> functions: \n            </p> \n            <div class=\"codeBlock\"><pre>// Get the scene\'s animation evaluator.\nFbxAnimEvaluator* lEvaluator = lScene-&gt;getEvaluator();\n&nbsp;\n// Get the node\'s default global transformation matrix.\nFbxAMatrix&amp; lGlobalTransform = lEvaluator-&gt;GetNodeGlobalTransform(lNode);\n\n// Get the node\'s default local transformation matrix.\nFbxAMatrix&amp; lLocalTransform = lEvaluator-&gt;GetNodeLocalTransform(lNode);</pre></div> \n            <p><a name=\"GUID-1AF6C842-ABCA-4139-B5D6-7226C9ABE720\"></a>An animated node\'s transformation matrix can be obtained for a specific point in time\n               by passing a <span class=\"code\">FbxTime</span> object. \n            </p> \n            <div class=\"codeBlock\"><pre>FbxTime lTime;\n\n// Set the time at two seconds.\nlTime.SetSecondDouble((float) 2);\n\n// Get the node\'s global transformation matrix at 2 seconds.\nFbxAMatrix&amp; lGlobalTransform = lNode-&gt;EvaluateGlobalTransform(lTime);</pre></div> \n            <div><a name=\"GUID-F51BF2E1-2186-4A86-BABD-8FA7EAA97F97\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>A node\'s global transformation matrix of cannot be explicitly set in the FBX SDK.\n                  \n               </div>\n            </div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_5BC1A6C28D554BCF857DE6517B22A5D6\"></a> \n            <h2><a name=\"GUID-1C61CE5E-AFC2-4D9A-9397-F0F098403047\"></a>Geometric Transformation Properties\n            </h2> \n            <p><a name=\"GUID-1DB11C50-902C-492F-AEB3-C0AD132C2CB5\"></a>The <span class=\"code\">FbxNode</span> geometric transformation properties (<span class=\"code\">FbxNode::GeometricTranslation</span>, <span class=\"code\">FbxNode::GeometricRotation</span>, and <span class=\"code\">FbxNode::GeometricScaling</span>) describe how a <span class=\"code\">FbxNodeAttribute</span> is offset from the <span class=\"code\">FbxNode</span>\'s local frame of reference. These geometric transforms are applied to the <span class=\"code\">FbxNodeAttribute</span> after the <span class=\"code\">FbxNode</span>\'s local transforms are computed, and are not inherited across the node hierarchy.\n               \n            </p> \n            <p><a name=\"GUID-520E0748-12C1-4B65-9CF0-80A92F9673FE\"></a> \n               <div><a name=\"GUID-720673D8-A24F-4C9D-98EC-F97232F53B00\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>The geometric transformation properties are related to how 3ds Max represents pivot\n                     information. It is comparable to 3ds Max\'s object-offset transformation. \n                  </div>\n               </div> \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_4DC5946B49F047DC99E203BD371DBEEB\"></a> \n            <h2><a name=\"GUID-EA25B1AE-2736-45CB-860B-52BE67FAEAF8\"></a>Baking Transform Components Into the Standard TRS Transforms\n            </h2> \n            <p><a name=\"GUID-92345007-10DF-415B-8B75-83CC110EB76A\"></a>The <span class=\"code\">FbxNode::ConvertPivotAnimationRecursive()</span> function lets you bake transform components: pre- and post-rotation, rotation and\n               scale pivots and offsets - inside the standard transforms - Translation, Rotation,\n               Scaling. Here is a code snippet. \n               <div class=\"codeBlock\"><pre>// Do this setup for each node (FbxNode).\n// We set up what we want to bake via ConvertPivotAnimationRecursive.\n// When the destination is set to 0, baking will occur.\n// When the destination value is set to the source’s value, the source values will be retained and not baked.\n{\n    FbxVector4 lZero(0,0,0);\n\n    // Activate pivot converting\n    pNode-&gt;SetPivotState(FbxNode::eSourcePivot, FbxNode::ePivotActive);\n    pNode-&gt;SetPivotState(FbxNode::eDestinationPivot, FbxNode::ePivotActive);\n\n    // We want to set all these to 0 and bake them into the transforms.\n    pNode-&gt;SetPostRotation(FbxNode::eDestinationPivot, lZero);\n    pNode-&gt;SetPreRotation(FbxNode::eDestinationPivot, lZero);\n    pNode-&gt;SetRotationOffset(FbxNode::eDestinationPivot, lZero);\n    pNode-&gt;SetScalingOffset(FbxNode::eDestinationPivot, lZero);\n    pNode-&gt;SetRotationPivot(FbxNode::eDestinationPivot, lZero);\n    pNode-&gt;SetScalingPivot(FbxNode::eDestinationPivot, lZero);\n\n    // This is to import in a system that supports rotation order.\n    // If rotation order is not supported, do this instead:\n    // pNode-&gt;SetRotationOrder(FbxNode::eDestinationPivot, FbxNode::eEulerXYZ);\n    ERotationOrder lRotationOrder;\n    pNode-&gt;GetRotationOrder(FbxNode::eSourcePivot, lRotationOrder);\n    pNode-&gt;SetRotationOrder(FbxNode::eDestinationPivot, lRotationOrder);\n\n    // Similarly, this is the case where geometric transforms are supported by the system.\n    // If geometric transforms are not supported, set them to zero instead of\n    // the source’s geometric transforms.\n    // Geometric transform = local transform, not inherited by children.\n    pNode-&gt;SetGeometricTranslation(FbxNode::eDestinationPivot, pNode-&gt;GetGeometricTranslation(FbxNode::eSourcePivot));\n    pNode-&gt;SetGeometricRotation(FbxNode::eDestinationPivot, pNode-&gt;GetGeometricRotation(FbxNode::eSourcePivot));\n    pNode-&gt;SetGeometricScaling(FbxNode::eDestinationPivot, pNode-&gt;GetGeometricScaling(FbxNode::eSourcePivot));\n\n    // Idem for quaternions.\n    pNode-&gt;SetUseQuaternionForInterpolation(FbxNode::eDestinationPivot, pNode-&gt;GetUseQuaternionForInterpolation(FbxNode::eSourcePivot));\n}\n\n// When the setup is done, call ConvertPivotAnimationRecursive to the scene’s root node.\n// Sampling rate e.g. 30.0.\nmScene-&gt;GetRootNode()-&gt;ConvertPivotAnimationRecursive(FbxNode::eDestinationPivot, lSamplingRate );</pre></div> \n               <div><a name=\"GUID-2B266E6E-3B5C-4F1D-924F-2D15D98DB3C7\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>To avoid re-computing the pivots matrices and updating the animation curves each time\n                     one of the parameters is changed, the FBX SDK only applies the new settings when an\n                     explicit call is made to <span class=\"code\">ResetPivotSetAndConvertAnimation()</span> or <span class=\"code\">ConvertPivotAnimationRecursive()</span>. \n                  </div>\n               </div> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";