var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-CC2D0441-C24A-457A-8C00-878760682B2D\">\n      <meta name=\"description\" content=\"This topic provides a set of references for information and technical support.\">\n      <meta name=\"indexterm\" content=\"technical support\">\n      <meta name=\"indexterm\" content=\"support: technical\">\n      <meta name=\"indexterm\" content=\"Autodesk Developer Network (Sparks)\">\n      <meta name=\"indexterm\" content=\"Sparks, Autodesk Developer Network\">\n      <meta name=\"indexterm\" content=\"discussion forums\">\n      <meta name=\"indexterm\" content=\"forums, discussion\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Information and Technical Support</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-CC2D0441-C24A-457A-8C00-878760682B2D\"></a><div class=\"head\">\n            <h1>Information and Technical Support</h1>\n         </div>\n         <p class=\"blurb\">This topic provides a set of references for information and technical support. </p>\n         <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6C0A\"></a> An array of sources of information are available for FBX SDK users including the <a href=\"http://www.autodesk.com/fbx\" target=\"_blank\">Autodesk FBX website</a>, the FBX Developer Help, the C++ Reference, the Autodesk Developer Network, and the\n            AREA discussion forums. \n         </p>\n         <div class=\"section\"><a name=\"SECTION_774DA9F23D3E4250BE9E0D7215F25A31\"></a> \n            <h2><a name=\"GUID-32DDCA7C-B25D-4BCF-A188-767A0A0868C1\"></a>FBX Developer Help\n            </h2> \n            <p><a name=\"GUID-8940FA9B-5943-455C-97ED-2C15EB42DA56\"></a>The document you are currently reading is the FBX Developer Help. Its purpose is to\n               get you familiar with key concepts in the FBX SDK. Its topics point you towards insightful\n               sample programs or relevant documentation within the C++ Reference. For any last minute\n               documentation changes, also refer to the <span class=\"filePath\">readme.txt</span> file in the root folder of your FBX SDK installation. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_0569C8D7DEFB4D88B0A95F601647FBDE\"></a> \n            <h2><a name=\"GUID-1FBAAE91-263B-4776-85ED-9185A3158D77\"></a>C++ Reference\n            </h2> \n            <p><a name=\"GUID-A293DDA6-5173-428E-9F96-8DB7CF29216B\"></a>The C++ Reference contains the API documentation for each class, member function,\n               enum, etc. Note that the FBX SDK was used to develop the FBX plug-ins for Autodesk\n               3ds Max and Autodesk Maya. It was also used to develop the FBX Converter and FBX for\n               QuickTime programs. The functionality of these tools provides a good introduction\n               to the capabilities of the FBX SDK (for links to these tools, see <a href=\"http://www.autodesk.com/fbx\" target=\"_blank\">http://www.autodesk.com/fbx</a>). \n            </p> \n            <div class=\"section\"><a name=\"SECTION_94247B47B3F549EA9EC16472A68311E6\"></a> \n               <h3><a name=\"GUID-1EDD1C06-1600-4FAF-BAEB-CAD3EABC1116\"></a>Reference Guide Naming Conventions\n               </h3> \n               <p><a name=\"GUID-DBE0E47B-B2F4-42CD-9EDD-24B894D133C2\"></a> The header files and sample programs in the reference guide generally abide to the\n                  following naming conventions. \n               </p> <a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6C0B\"></a><div class=\"table-ruled\">\n                  <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n                     <colgroup>\n                        <col width=\"50%\">\n                        <col width=\"50%\">\n                     </colgroup>\n                     <tr class=\"ruled-heading\">\n                        <th class=\"table-heading\">Prefix </th>\n                        <th class=\"table-heading\">Notes </th>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <span class=\"code\">Fbx</span> \n                        </td>\n                        <td class=\"table-body\">Most FBX SDK class names begin with <span class=\"code\">Fbx</span>. Examples: <span class=\"code\">FbxNode</span>, <span class=\"code\">FbxScene</span>, <span class=\"code\">FbxCamera</span> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <span class=\"code\">p</span> \n                        </td>\n                        <td class=\"table-body\">Parameters passed to a member function begin with lower case “P”. Examples: <span class=\"code\">pWriteFileFormat</span>, <span class=\"code\">pScene</span>, <span class=\"code\">pFilename</span> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <span class=\"code\">l</span> \n                        </td>\n                        <td class=\"table-body\">Local variables begin with lower-case “L”. Examples: <span class=\"code\">lWriteFileFormat</span>, <span class=\"code\">lScene</span>, <span class=\"code\">lFilename</span> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-even-row\">\n                        <td class=\"table-body\"> <span class=\"code\">g</span> \n                        </td>\n                        <td class=\"table-body\">Global variables begin with lower-case “G”. Examples: <span class=\"code\">gStart</span>, <span class=\"code\">gStop</span>, <span class=\"code\">gCurrentTime</span> \n                        </td>\n                     </tr>\n                     <tr class=\"ruled-odd-row\">\n                        <td class=\"table-body\"> <span class=\"code\">m</span> \n                        </td>\n                        <td class=\"table-body\">Member data (member variables) begin with lower-case “M”. Examples: <span class=\"code\">mDescription</span>, <span class=\"code\">mImportname</span>, <span class=\"code\">mSelect</span> \n                        </td>\n                     </tr>\n                  </table>\n               </div> \n            </div> \n         </div>\n         <div class=\"section\"><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6C08\"></a> \n            <h2><a name=\"GUID-C72CB3DA-58AC-45AF-BCC0-4739CBF4459B\"></a>Autodesk Developer Network (Sparks)\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6C07\"></a> Technical support for the FBX SDK is provided through the Autodesk Developer Network\n               (ADN) Sparks 3rd party developer program. The ADN Sparks program is based on an annual\n               membership fee. Program details, benefits, and pricing can be found on the <a href=\"http://usa.autodesk.com/adsk/servlet/index?siteID=123112&amp;id=7478532\" target=\"_blank\">Autodesk Developer Network</a> web page. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"WS8E4C2438B09B7F9C-1C1791801197CCD8A5F-7FF3\"></a> \n            <h2><a name=\"GUID-2E144D5A-0859-4621-8DDE-5947339A5124\"></a>Discussion Forums\n            </h2> \n            <p><a name=\"WS1A9193826455F5FF-150B16DA11960D83164-6C05\"></a> For free, user-to-user discussion forums for developers and others, visit the FBX\n               section of AREA, Autodesk’s community for digital entertainment and visualization:\n               <a href=\"http://area.autodesk.com/forum/autodesk-fbx/\" target=\"_blank\">http://area.autodesk.com/forum/autodesk-fbx/</a> \n            </p> \n         </div>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";