var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-E7B43ABC-7F96-4A75-8769-3B7574F768AB\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>Scene Showing Interrelationships among Data Structures</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E7B43ABC-7F96-4A75-8769-3B7574F768AB\"></a><div class=\"head\">\n            <h1>Scene Showing Interrelationships among Data Structures</h1>\n         </div>\n         <p><a name=\"WS1A9193826455F5FF7B1DE9F8127315F1B54-6028\"></a>This example helps in understanding how the data structures are interrelated in a\n            typical scene. \n         </p><a name=\"WS1A9193826455F5FF7B1DE9F8127315F1B54-6027\"></a><div class=\"figure-anchor\"><img src=\"../images/GUID-372DB0D5-5E91-4BAA-9D0E-5CBD0535111F-low.png\"></div>\n         <p><a name=\"WS1A9193826455F5FF7B1DE9F8127315F1B54-6026\"></a>The example scene in the figure has three FBX objects (FBXObject0, FBXObject1, and\n            FBXObject2), each of which have one FBX property (Obj0Property, Obj1Property, and\n            Obj2Property) that can be animated. These three FBX properties have default values\n            of a, b, and c respectively. The data structures are connected to each other through\n            object-to-object (OO) connections and object-to-property (OP) connections as indicated\n            in the figure. \n         </p>\n         <p><a name=\"WS1A9193826455F5FF7B1DE9F8127315F1B54-6025\"></a>The example scene has one animation stack that contains three animation layers. The\n            following table explains how the animation layers and other data structures affect\n            the value of the FBX property. \n         </p><a name=\"TABLE_8167DB9FDAA74B6E9DCE1AB7B114FCC3\"></a><div class=\"table-ruled\">\n            <table cellpadding=\"0\" cellspacing=\"0\" class=\"ruled\">\n               <colgroup>\n                  <col width=\"19.047619047619047%\">\n                  <col width=\"47.61904761904761%\">\n                  <col width=\"33.33333333333333%\">\n               </colgroup>\n               <tr class=\"ruled-heading\">\n                  <th class=\"table-heading\">Animation Layer </th>\n                  <th class=\"table-heading\" align=\"center\">Description </th>\n                  <th class=\"table-heading\" align=\"center\">Value of FBX Property </th>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\">AnimationLayer0 </td>\n                  <td class=\"table-body\"> <a name=\"GUID-C1897B38-D227-4FA8-9814-7992486DAFF4\"></a><p class=\"table-body\">AnimationLayer0 is the base layer, which is connected to one animation curve node\n                        (CurveNode0). This animation curve node is not connected to any animation curves,\n                        so it is not used to apply animation to a FBX object. However, this animation curve\n                        node is connected to one FBX property (Obj0Property). \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"GUID-2E76834A-5167-4169-9D33-E8BFFA3347FE\"></a><p class=\"table-body\">In AnimationLayer0, the Obj0Property’s value of <em class=\"mild\">a</em> is overridden by the animation curve node’s value of <em class=\"mild\">aa0</em>. \n                     </p> <a name=\"GUID-77E6C98B-8F5C-460F-BE8B-2A9EDB86FC4A\"></a><p class=\"table-body\">Generally, in the absence of an animation curve or when ignoring the animation curve,\n                        the value in the animation curve node overrides the value of the FBX property. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-even-row\">\n                  <td class=\"table-body\">AnimationLayer1 </td>\n                  <td class=\"table-body\"> <a name=\"GUID-DF043637-BA37-4B5C-A131-6E6C595F99E0\"></a><p class=\"table-body\">AnimationLayer1 is connected to two animation curve nodes: CurveNode1 and CurveNode2.\n                        \n                     </p> <a name=\"UL_EADDC19F4FE642138AFFD4B8F420703F\"></a><ul>\n                        <li>CurveNode1 is connected to one FBX property (Obj0Property) and to one animation curve\n                           (AnimationCurve0). \n                        </li>\n                        <li>CurveNode2 is connected to one FBX property (Obj1Property) and one animation curve\n                           (AnimationCurve1). \n                        </li>\n                     </ul> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"GUID-51C7B9B9-78DB-483D-A3F7-02FFB9D7CD4F\"></a><p class=\"table-body\">In AnimationLayer1, the value of Obj0Property is neither <em class=\"mild\">a</em> nor <em class=\"mild\">aa1</em>, but determined by the values over time in AnimationCurve0. \n                     </p> <a name=\"GUID-1AF201A5-9615-445E-B9C0-891A8A6C0FF0\"></a><p class=\"table-body\"> In AnimationLayer1, the value of Obj1Property is neither <em class=\"mild\">b</em> nor <em class=\"mild\">bb1</em>, but determined by the values over time in AnimationCurve1. \n                     </p> \n                  </td>\n               </tr>\n               <tr class=\"ruled-odd-row\">\n                  <td class=\"table-body\">AnimationLayer2 </td>\n                  <td class=\"table-body\"> <a name=\"GUID-17A27536-3904-414D-A6AD-0BC9C7245535\"></a><p class=\"table-body\">AnimationLayer2 is connected to one curve node (CurveNode3), which connects one animation\n                        curve (AnimationCurve0) and one FBX property (Obj1Property). \n                     </p> \n                  </td>\n                  <td class=\"table-body\"> <a name=\"GUID-E652D7EE-9546-4DC8-A443-089B516A676C\"></a><p class=\"table-body\">In AnimationLayer2, the value of Obj1Property is neither <em class=\"mild\">b</em> nor <em class=\"mild\">bb2</em>, but determined by the values over time in AnimationCurve0. \n                     </p> \n                  </td>\n               </tr>\n            </table>\n         </div>\n         <div><a name=\"GUID-9376CDEA-117D-463D-A7A5-F5914D406037\"></a><div class=\"note-note\"><span class=\"label label-target-language\">NOTE:</span>AnimationCurve0 is connected to CurveNode1 and CurveNode3. Therefore, when the scene\n               is evaluated, AnimationCurve0 affects two different FBX properties (Obj0Property and\n               Obj2Property) of two different FBX objects (FBXObject0 and FBXObject1) in two different\n               animation layers (AnimationLayer1 and AnimationLayer2). Additionally, how the animation\n               data is evaluated depends not only on the animation curves, but also on the blend\n               mode and the blend weight of each animation layer. See <span class=\"char_link\"><a href=\"GUID-9B6410C4-6441-4CAB-BFF5-FE6B07764232.htm\">Blending Animation</a></span> for more information on blending. \n            </div>\n         </div>\n         <p><a name=\"WS73099CC142F48755-5DCDA9B6127315F9A85-7743\"></a>The FBX SDK animation system provides a lot of flexibility, but it is your responsibility\n            to ensure that the interrelationships among the data structures are valid. \n         </p>\n         <div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";