var topic = "<!DOCTYPE html>\r\n\n<!-- saved from url=(0024)http://docs.autodesk.com -->\r\n<html>\n   <head>\n      <meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\">\n      <meta name=\"product\" content=\"FBX\">\n      <meta name=\"release\" content=\"2017\">\n      <meta name=\"book\" content=\"Developer\">\n      <meta name=\"created\" content=\"2017-03-15\">\n      <meta name=\"topicid\" content=\"GUID-E802CA6C-4608-41ED-A35A-017CE6E9E8DD\">\n      <meta name=\"description\" content=\"This section presents the FBX SDK object model. Several key concepts are explained here to give you an intuition of how to use the FBX SDK effectively.\">\n      <meta name=\"topic-type\" content=\"concept\">\n      <title>FBX SDK Object Model</title><script language=\"javascript\">var index = \'index.html\';</script></head>\n   <body height=\"100%\">\n      <div class=\"body_content\" id=\"body-content\" dir=\"ltr\"><a name=\"GUID-E802CA6C-4608-41ED-A35A-017CE6E9E8DD\"></a><div class=\"head\">\n            <h1>FBX SDK Object Model </h1>\n         </div>\n         <p class=\"blurb\">This section presents the FBX SDK object model. Several key concepts are explained\n            here to give you an intuition of how to use the FBX SDK effectively. \n         </p>\n         <div class=\"section\"><a name=\"SECTION_9B3DCCB3DFBE44B595EE38303FB58219\"></a> \n            <h2><a name=\"GUID-8D71663B-8A5C-47B1-ABF7-E0EB3CA9D50C\"></a>Memory Management\n            </h2> \n            <p><a name=\"GUID-A2F4626A-8161-4E30-A1E0-F5E944E270CB\"></a>Memory management within the FBX SDK is performed by the FBX SDK Manager object (<span class=\"code\">FbxManager</span>). The <span class=\"code\">FbxManager</span> singleton is responsible for creating, manipulating, and destroying objects used\n               by the SDK. For more information, see <span class=\"char_link\"><a href=\"GUID-B3BF2A41-2262-4706-ABB3-D3C861B3F03B.htm\">Managing memory with the FBX SDK manager</a></span>. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_818D225828514DFD9886F0C97D7027D9\"></a> \n            <h2><a name=\"GUID-0E1628CE-7DF3-456E-8D1A-F259CB709F63\"></a>Objects\n            </h2> \n            <p><a name=\"GUID-0C2AFB6E-5418-4714-8807-ACC0042036CC\"></a>Most of the classes in the FBX SDK are derived from <span class=\"code\">FbxObject</span>. Consult the <span class=\"char_link\"><a href=\"GUID-5D8BFE45-723E-4BD9-846B-E2B2540157C9.htm\">FBX Objects</a></span> topic and the <span class=\"code\">FbxObject</span> class reference page for more information. Examples of classes derived from <span class=\"code\">FbxObject</span> include scene nodes, I/O objects, and collections. \n            </p> \n            <div class=\"section\"><a name=\"SECTION_C72C0A8C53984993B09368D9DDABB007\"></a> \n               <h3><a name=\"GUID-3C4828E1-B46D-4DC5-979B-BFA458F240F5\"></a>Nodes\n               </h3> \n               <p><a name=\"GUID-217FE410-B071-492E-9419-94294F82849B\"></a>The FBX scene graph is organized as a tree of <span class=\"code\">FbxNode</span> objects. Associated to these nodes are cameras, meshes, NURBS, lights, and all the\n                  other scene elements. These scene elements are specialized instances of <span class=\"code\">FbxNodeAttribute</span>. For more information, see <span class=\"char_link\"><a href=\"GUID-F194000D-5AD4-49C1-86CC-5DAC2CE64E97.htm\">Nodes and the Scene Graph</a></span>. \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_272D11C803D84E7CA8CB6DBD34F5E11F\"></a> \n               <h3><a name=\"GUID-93E253FF-F018-439E-B42C-1188DA717C91\"></a>IO Objects\n               </h3> \n               <p><a name=\"GUID-63ADDDCB-A7E1-47B9-BAF9-31E62E0A85D0\"></a><span class=\"code\">FbxImporter</span> and <span class=\"code\">FbxExporter</span> objects are used to import and export scenes in the FBX SDK. For more information,\n                  consult the <span class=\"char_link\"><a href=\"GUID-B0455682-8B84-41FC-BCAA-D746F032261F.htm\">Importing and Exporting a Scene</a></span> section, as well as the class reference pages of <span class=\"code\">FbxIO</span>, <span class=\"code\">FbxImporter</span>, and <span class=\"code\">FbxExporter</span>. \n               </p> \n            </div> \n            <div class=\"section\"><a name=\"SECTION_E3C14FBC21624362B7A54721213296E6\"></a> \n               <h3><a name=\"GUID-93AFE8F4-2242-43DC-9BCC-BD2176BC9F72\"></a>Collections\n               </h3> \n               <p><a name=\"GUID-8E70DF01-3C02-4432-B4BE-A465F935311B\"></a>Most container classes are derived from the <span class=\"code\">FbxCollection</span> class, whose member functions include <span class=\"code\">FbxCollection::AddMember()</span>, <span class=\"code\">FbxCollection::RemoveMember()</span>, <span class=\"code\">FbxCollection::FindMember()</span>, <span class=\"code\">FbxCollection::IsMember()</span>, <span class=\"code\">FbxCollection::SetSelected()</span>, etc. \n               </p> \n            </div> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_37B8BF5F20BB4AACAA1FD35856FD28BC\"></a> \n            <h2><a name=\"GUID-D23837A0-B1AA-4D09-923A-7CE5B0345938\"></a>Object Properties\n            </h2> \n            <p><a name=\"GUID-A2F26E83-AE4F-46DC-A191-028ADAC3EA3A\"></a>An FBX object such as <span class=\"code\">FbxNode</span> uses FBX properties (<span class=\"code\">FbxProperty</span>) rather than conventional C++ member variables. FBX properties allow for strongly\n               typed data to be dynamically added to FBX objects. For more information, see <span class=\"char_link\"><a href=\"GUID-283ED424-E506-4A29-848F-9EAC8F1C4AF9.htm\">FBX Properties</a></span>. \n            </p> \n         </div>\n         <div class=\"section\"><a name=\"SECTION_34D7461773264395B7312CB3C9D29E9C\"></a> \n            <h2><a name=\"GUID-F1726E8B-EF9B-4770-92E6-70AA49773AC1\"></a>Connections\n            </h2> \n            <p><a name=\"GUID-92E67D5E-CCA5-477A-B617-812740E05E95\"></a>The concept of connections is relevant to understanding the FBX SDK\'s object model.\n               Connections can bind objects to one another, properties to one another, objects to\n               properties, and vice versa. Note that there is no <span class=\"code\">Connection</span> class available in the API. Rather, connections can only be manipulated with the\n               <span class=\"code\">FbxObject</span> and <span class=\"code\">FbxProperty</span> connection-related member functions such as <span class=\"code\">FbxObject::GetSrcObject()</span>. For more information, see <span class=\"char_link\"><a href=\"GUID-BB63A93A-7663-4256-B060-8EA35CB0FF3A.htm\">Connections</a></span>. \n            </p> \n         </div><span class=\"noindex\">\n            <div class=\"topic-list\">\n               <h4 class=\"related\">Topics in this section</h4>\n               <ul class=\"jumplist\">\n                  <li class=\"topiclist-litem\"><a href=\"GUID-B3BF2A41-2262-4706-ABB3-D3C861B3F03B.htm\">Managing Memory with the FBX SDK Manager</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-5D8BFE45-723E-4BD9-846B-E2B2540157C9.htm\">FBX Objects</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-283ED424-E506-4A29-848F-9EAC8F1C4AF9.htm\">FBX Properties</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-BB63A93A-7663-4256-B060-8EA35CB0FF3A.htm\">Connections</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-5509751F-8679-4D32-987D-8343FD8F6D1A.htm\">Error Handling</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-D3844B1D-4E74-4C64-AD79-14B00EB1FE4C.htm\">Supported String Formats</a></li>\n                  <li class=\"topiclist-litem\"><a href=\"GUID-5FAF6FE0-5904-45C3-915A-DB0C9586D45B.htm\">Customizing the FBX SDK</a><p>This topic presents how to customize or extend the features of the FBX SDK. </p>\n                  </li>\n               </ul>\n            </div></span><div class=\"footer-block\"><a href=\"..\" class=\"comments-anchor\" target=\"_blank\"><span class=\"comments-link\">Please send us your comment about this page</span></a></div><br><p class=\"footer-license-block\"><a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\"><img alt=\"Creative Commons License\" style=\"border-width: 0;\" src=\"../images/ccLink.png\"></a>&nbsp;<em>Except where otherwise noted, this work is licensed under a <a rel=\"license\" href=\"http://creativecommons.org/licenses/by-nc-sa/3.0/\" target=\"_blank\">Creative Commons Attribution-NonCommercial-ShareAlike 3.0 Unported License</a>. Please see the <a href=\"http://autodesk.com/creativecommons\" target=\"_blank\">Autodesk Creative Commons FAQ</a> for more information.</em></p><br></div>\n   </body>\n</html>";